<? require "../lib.php"?>
<? aheader("Luca Changelog"); ?>

<h3>From 1.02 to 1.1</h3>
<p>
Database changes (to pave the road to Firebird/Interbase support):
<li>
<ul>xuser.password - pwd (database column only; SQLObject class keeps the old attribute name)
<ul>journal.day - tday
<ul>journal.value - tvalue
<ul>xuser.email_address size reduced to 250
<ul>costcenters.inactive - notactive
<ul>stdjournals.inactive - notactive
<ul>accounts.inactive - notactive
<ul>classes.is_result - is_income (database column as well as SQLObject class)
</li>

<h3>From 1.01 to 1.02</h3>
<p>
<ul>
<li> Passed automated tests for Postgres database
<li> Automated testing now does more than 8000 tests
<li>LucaMobile: JSON adopted as RPC protocol, replacing the homegrown marhshalling functions
<li>LucaMobile server integrated into main Luca application
<li>LucaMobile: Added support for HTTP-based requests at server side and to Linux client
<li>Bluetooth listener runs as a separate thread in Luca application.
<li>Bluetooth now relies on LightBlue library alone, in server side. This ensures the Bluetooth code will be compatible with major operating systems.
<li>If LightBlue is not installed, the application fails gracefully (keeps running but does not listen to Bluetooth)
<li> AJAX request error in Safari browser. It is a Turbogears bug <a href="http://trac.turbogears.org/ticket/1284?format=rss">(ticket #1284)</a>.
</ul>

<h3>From 1.0 to 1.01</h3>
<p>
<ul>
<li>Test routine scope increased
<li>Fixed permission checks for journal entries checksum/get chart AJAX calls
<li>Fixed permission VIP for sys_qlogs controller, now it accepts the ADMIN wildcard (so ADMIN users can query all users' log)
<li>Journal entries 'Transaction' column name changed to 'Transa' since the first conflicts with SQLite 
<li>Refactored permission failure, now it raises an exception
<li>Refactored mylib.py, parts moved to accountlib.py and model.py where they belong
<li>Foreign keys/referential integrity: now Luca also checks them, so SQLite can be safely used even though it has no referential integrity features
<li>SQLite3 is now the database engine behind Luca tryout demo
<li>SQLite added as an option to run the test routines
<li>Explicit _testing_ controller parameter removed;  moved to model._testing_
<li>Charts of accounts page is now collapsable (user can expand/collapse account groups)
<li>Collapsable view also added to journal entries, balance report and income/expense statement. (They are always printed in full, independent of collapsed/expanded groups in screen)
<li>Log describes which columns were changed in a row update, making it easier to e.g. discover who changed which data in an audit
<li>Testing routines: added partial auditing version counters
</ul>
<p>Database changes since 1.0:

<ul>
<li>Journal entries (table 'journal'): 'transaction' column name changed to 'transa' because 'transaction' appears to be a reserved SQL word in SQLite.
</ul>

<h3>From 0.9 to 1.0</h3>
<p>
<ul>

<li>Testing routine refactored. Most of the testing code now lies in the controllers themselves, making it way easier to extend tests for each controller.
<li>Removed photo from journal entries table; a new file with audit trail documents will replace this in the future, allowing any kind of file (not only photos).
<li>Fixed problem in session defaults storage (backported to 0.9)
<li>Upgrade to work under Turbogears 1.0.2.2 and Python 2.5
<li>Small refactoring in reports, making all of them simple_report subclasses (mostly to aid testing)
<li>Fixed journal entry javascript problem: sometimes editing an entry would bring the debit account of an formerly inserted entry (backported to 0.9)
<li>Journal entries: filter accounts also on filter onblur event (important for Safari)
<li>All AJAX controllers: go to page top when inserting/editing.
<li>mylib.ctod: accept a partial date and complete with month and/or year from current machine time.
<li>
<li>

</ul>

<p>Database changes since 0.9:

<ul>
<li>Journal: removed 'photo'
</ul>


<h3>From 0.81 to 0.9</h3>
<p>
<ul>

<li>Added Transaction ID column for journals, as a hook for future enhancements
<li>Do not allow to remove journal entries anymore, they can be 'cancelled' only
<li>Batches can only be removed when they are still empty
<li>Batches are annotated as 'cancelled' when all journals inside it have been cancelled
<li>Refactoring of journal entry update in 'lite' page
<li>Fixed division by zero in report_incomeavg, when a period of just one day is selected
<li>Mobile client for Series 60: newest version of PyS60 also returns regular strings in [e32]dbm API, as everybody else

</ul>

<p>Database changes since 0.7:

<ul>
<li>Journal: added 'transaction' column, int default null, non-uniquely indexed.
<li>Journal: added 'cancelled' column, int not null default zero.
<li>Journal: key 'h' (based on hash column) changed from non-unique to unique.
</ul>

<h3>From 0.8 to 0.81</h3>
<p>
<ul>

<li>ENTER works as the Submit button in AJAX forms too, including Safari
<li>Journals: fixed version bumping problem (was updating page needlessly)
<li>Journals: fixed default values for new journal entries (were not ok for one-legged entries)
<li>Journals: debit now inserted in table before credit
<li>Financial calculator: fixed in Safari
<li>Bug in Turbogears for Safari client and Linux server, turned out to be the Turbogears bug #1284, will be fixed in TG 1.0.2
</ul>

<p>Database changes since 0.8: None

<h3>From 0.7 to 0.8</h3>
<p>
<ul>

<li>Added CSS style for printed media
<li>Reports and some controllers improved to look better when printed
<li>User can change its own password (new option in menu)
<li>Preliminary tests with SQLite and PostgreSQL as databases
<li>Added workarounds for SQLObject problems with PostgreSQL
<li>Automated tests: coverage has been increased from 55% to 90%
<li>Fixed small bugs in journal entries new rows (detected by testing)
<li>Fixed security bug in reports (detected by testing)
<li>Added _testing_ parameter in some "lite" calls to return error status instead of redirecting
<li>Logging level changed from "info" to "error"
<li>Several other minor bugs fixed
</ul>

<p>Database changes since 0.7: None

<h3>From 0.65 to 0.7</h3>
<p>
<ul>

<li>"Ported" to Mac OS X (worked right away)
<ul>
<li>Development from now on will be part-time Mac, part-time Linux
<li>AJAX pages ported to Safari. Small changes to add support to this browser:
<ul>
<li>Moved onClick event connections to inline onClick attributes in pages (at Safari, form buttons are not available for event connection at onLoad event time). Inline Javascript is uglier but works.
</ul>
<li>Added Mac OS X support for LucaMobile server. Issues: depends on LightBlue library and serves only one client at atime since Mac OS X Bluetooth sockets are not select()able.
</ul>
<li>AJAX in-place updating for rows:
<ul>
<li>standartize API for formatting/conversion functions, so both Kid and AJAX will get formatted data from a single place. Previously, most formatting was being done in Kid templates and AJAX update had no way to get formatted data to update the page with. 
<li>all AJAX tables now support in-place update (except for parent X child pages that are not used often anyway).
<li>when two or more different users update the same data view, page reloading is forced (to avoid working on old data).
<li>not showing "flash" (page top) messages for rows updated in place via AJAX (the feedback is the page change itself).
<li>Journal entries checksum is updated via AJAX (no need to reload the page to see if the checksums are balanced)
</ul>
<li>Batches page: add short-circuit link to journal editing page
<li>Fixed some English terms (Thanks to Aldenor Martins' Christmas gift: an English dictionary of accounting terms)
<li>Explicit UTF-8 encoding parameter removed from UnicodeString form validators (they already know how to decode based on page charset)
<li>README install instructions cleanup (Unicode interface between SQLObject and MySQLDB still sucks, so the related patches are still needed)
<li>Fixed session-related errors when browser cookies are not enabled (defaults to an "empty" session, cookies are still needed to really make use of the system)
<li>"Photo" column in journal entries tabled changed SQLObject type from "PickleCol" to "BLOBCol" (SQLObject was raising strange exceptions when the column was filled with a "None" object).
</ul>

<p>Database changes since 0.65:
<ul>
<li>alter table cmos add orgs_version int not null default 0;
<li>alter table cmos add charts_version int not null default 0;
<li>alter table cmos add xuser_version int not null default 0;
<li>alter table cmos add xgroup_version int not null default 0;
<li>alter table orgs add version int not null default 0;
<li>alter table batches add version int not null default 0;
<li>alter table journal modify photo mediumblob;
</ul>
<p>Run ./upgrade_database for a fully automatic update.

<h3>From 0.6 to 0.65</h3>
<p>
<ul>

<li> Added timestamp at the end of reports
<li> Ledger report: show journal IDs
<li> Cherrypy.session insulated in mylib.session() to aid tests where cherrypy.session does not work
<li> Journals: show distinct dates in list
<li> Journals: append new journal: test debit different from credit
<li> Journals: editing w/ inactive account does not show account correctly
<li> Journals: copy both debit and credit accounts from last entry to new entry
<li> Fix organization X user permission test (perm_org)
<li> Non-error messages in "lite" controllers (added method simple_table.flash_at_edit)
<li> AJAX controllers: remove special ENTER handling (standard = best :)
<li> Ledger report - show account name in report
<li> Ledger and journal reports: batch # is a link to journal edit controller
<li> Show org IDs in drop-down boxes
<li> Filled all validators with if_invalid= parameters (avoids ugly errors with grossly unexpected parameters)
<li> Block fetching of new row when user has no read permission (could leak information from last new row)
<li> Remove some features from "lite" pages, like mobile toogling 
<li> AJAX pages: replace most buttons by links, except by the editing form (for now)
<li> Accounts of the chart: update/remove data in place in AJAX (avoids long-delayed page updates)
<li> Accounts of the chart: do not ask if an account is aggregate (it can be derived by the code right away)
<li> Standard journals and cost centers: toogle mobile/inactive

</ul>

<p>No database changes since 0.6.

<h3>From 0.5 to 0.6</h3>
<p>
<ul>

<li>Topbar menu link redirects to the default user mode (AJAX or lite). The
alternative mode is still offered but clearly identified as such.

<li>The financial calculator has been readded in lite menu, since most
browsers should be able to handle its Javascript (there is no AJAX 
fancy things in that calculator)

<li>Explicit transactions removed since each visit runs in its own
transaction thanks to TurboGears, so there was no point in creating a
second transaction. It was causing problems e.g. TG transaction did not
readily see the data from the other transaction.

<li>Controllers with critical sections that need to rollback in case of some
error have been dealt with differently: the Turbogears transaction
is committed just before the beginning of the critical section, so
the previous work (logging, session registering etc.) is not lost
in the case of rollbacking TG's own transaction.

<li>balance_closing.check() flow was improved by using exceptions,
avoiding multiple return exit points.

<li>Balance closing works harder to detect whether another closing
has already been done in the same period (partially or totally overlapped).

<li>simple_table.last_new_row_data (last data from a just included row,
that is offered as defaults to the next new row) moved to cherrypy.session
avoiding race conditions between simultaneous users (affects all basic
controllers).

<li>All SQL select's checked about proper exception handling (in SQLObject,
select's are lazy evaluated which can trigger an exception far from the
select() call). Some cases e.g. exceptions during Kid template processing
still are around, but they will only happen if something really bad happens
e.g. the database is shut down.

<li>Added a "throbber" (animated GIF image) in AJAX controllers, so the
user has a feedback while an AJAX transaction is being processed. Especially
important in high-latency connections.

<li>AJAX forms will show informative (blue) messsages, not only errors.
Important in streamlined row adds, so the user has a textual feedback
about the lastly-added data.

<li> Journal entry accepts both debit and credit accounts in one shot 
(in new journals) to speed up entry of paired journals (debit and credit of
the same value, the most common type). The original (and unpractical) convention
of identifying debit/credit by the value signal has been removed (it only
remains in the SQL database, where it works well).

<li> Charts of accounts: Aggregate accounts no longer need to be of the
same class of their parents. This obligation only holds for non-aggregate
accounts. This change will allow bank-style charts where income and expense
accounts belong to the Equity hierarchy.

<li>Charts of accounts: except for top-level accounts, and aggregate accounts
that are of a different class from its parent (see item above), the user
no longer needs to specify the account class; it will be automatically
derived from parent account. The idea is to allow faster data entry.

<li>Handle correctly the inactive items of some tables (accounts, cost centers).
New journals must not accept inactive items, but inactive items should be
accepted while editing old rows (since the inactive item might have been 
active by the time the row was included). The inactive state of items
is now clearly stated in respective combo boxes.

<li> Costcenters and standard journals were added the "inactive" column,
  so they can be declared inactive and will no longer be accepted in new
  journals. 

<li> The user has some new configurations: AJAX/lite default menu (e.g. to
disable AJAX for an user that is known to use an outdated browser etc.). 
Thousand separator, decimal separator and date format are also configured
per-user. New users will copy the default parameters from administrator
(so configure the admin with the defauls you like best before including
new users).

<li>MobileClient: server side first checks the organization's active period
before it commits the journals. Avoids adding extraneous journals in unexpected
dates.

<li>Journal entries: in the AJAX version, the accounts are loaded via JSON,
and only reloaded when they change. User can filter the account list locally
to find faster the wanted accounts. 

<li>Journal entries: a shortcut to reopen batch has been added. Useful to
fix data coming from mobile client without having to access the batches
controller.

<li>Journal entries: a default standard journal entry is fetched from
the debit/credit accounts, if any account supplies a default one. This
is handled entirely client-side and is AJAX version-only. The real
utility of this feature is a bit doubtful, however (I implemented that
since it was planned and seemed to be a good idea by then).

<li>Small and sparse fixes in CSS.

<li> The database is deemed FROZEN by this version. Next database updates 
must bring clear upgrade instructions in changelogs, as well as SQL scripts
to make the update automatically.

<li> Cmos table will contain the database version (linked to the Luca model
version). This will make automatic database updates easier in the future.

<li>Automated tests of simple tables are working. Test of batches,
journals, reports etc. still need to be developed. The test is not yet
friendly for an user to run since it depends on a Turbogears patch
(extra/test_id.patch, TG ticket #1166, should be integrated in TG 1.0 final).
</ul>

<p>Database changes since 0.5:

<ul>
<li>Added inactive (INT NOT NULL) in stdjournals
<li>Added inactive (INT NOT NULL) in costcenters
<li>Added database_version (TEXT NOT NULL) in cmos, default value "0.6"
<li>Added lite (INT NOT NULL) in xuser 
<li>Added locale (TEXT NOT NULL) in xuser, default value ".,Y/m/d"
</ul>

<? footer("/", "en"); ?>

