<? require "../lib.php"?>
<? aheader("Luca Development Diary - from 0.01 to 0.1"); ?>
<p>
2006/06/19
<p>
I have added a couple testing pages. First the Javascript financial calculator
that I already had, and then persistent sessions testing, copied from TurboGears
documentation.
<p>
Another thing I tried to do but I did not manage to do the exact way I wanted,
is to keep per-window variables. They are like session variables, but they are
inheried only by the new pages/windows spawn from the original window. 
<p>
For example, the same user (hence the same session) can open two or more
windows to work in two or more different organizations. If I just use
a session variable to keep the organization ID, one window will rewrite
the others' defaults. I would like to have "forked" session variables,
one for each window. If the user closes one window, he loses that branch
of session variables; that is expected.
<p>
The master (root) session variable pool continues to exist, and it
would contain the last updated defaults. If the user closed all windows,
or if a variable not contained in a session branch is requested, the
master session pool is called.
<p>
Ok, enough dreams :) It is difficult to implement this kind of per-window
session variable pool because sessions are based on cookies, and cookies
are global per browser. Per-window session control demands a hidden input
in each page, renewed in every access. Since each page load potentially
generates a new "fork", discarded branches would have to be evicted someway.
<p>
After all these considerations, seems that the only rational way to have
per-branch default values is to put explicitely those variables in
hidden inputs i.e. not to try to make this transparent, and delegate the
storage of these per-branch defaults to the client, so the server can
"forget" them.
<p>
2006/06/20
<p>
The system menu is in place, served when root page is requested. Having a menu
from the beginning of system development is nice because you have the exact
perspective of all planned function points.
<p>
2006/06/21
<p>
Today I finished the model (luca/model.py) initial development. Initially
I had all tables, indexes etc. created by a SQL script, becaus I had one
inherited from CTB system, and I felt more comfortable than using 
SQLObject table classes.
<p>
After defining the database and creating the table classes, I had to correct
some things in my data dictionary in order to better reflect the SQLObject
way of like: integer auto incrementing IDs as primary keys, all foreign key
relationships done via these IDs etc.
<p>
After I had all these table classes done, I began to like SQLObject more,
and moved the table creation to a Python script that called 
class.createTable() for all tables. Only the CREATE DATABASE thing remained
in a SQL script (and still remains that way). 
<p>
Some Luca tables need initial rows to be inserted. They were inserted via
SQLObject in the database creation script, but I discovered that TurboGears
creates the tables on demand. 
<p>
I discovered this fact while playing with with Identity support. BTW, I had 
to add six tables to my data dictionary: xuser, xgroup, xpermission and 
visitiidentity, user_group and group_permission.  The last two ones are 
automatically created when you specify RelatedJoin's table classes, so you
don't even need to code table classes for many-to-many relationships!
<p>
(See 2006/06/22 for a change in data dictionary)
<p>
Back to the rows that need to be inserted, I created createTable() class
methods in my table classes. These methods must first call the parent method
(SQLObject.createTable()) which actually creates the table, and then insert
the rows. 
<p>
Class methods are a bit esoteric, and I could not figure out by myself how
to call the super method passing the daughter class as the first parameter.
Finally, I asked at #sqlobject channel at FreeNode, and they were quick to
give me the magic hint:
<pre>
@classmethod
def createTable(cls, *args, **kw):
        super(MyTableClass, cls).createTable(*args, **kw)
	# then proceed to create rows here
</pre>
<p>
After this hint, all table calls could be made independent, in the sense that
the table creation will imply the creation of necessary initial rows. So the
only thing that is needed to do when installing Luca, is to create the database 
itself, and start Luca. The tables are all created automatically on demand.
<p>
2006/06/22
<p>
I have changed slightly the creation of n-by-n relationship intermediate 
tables (user_group and group_permission). SQLObject does not create a 
compound unique index with all columns in the intermediate table. That 
allows for (ill) multiple relationships that do not make sense. For example,
between a given group and a given permission, there should be 0 or 1 
rows in the intermediate table, binding or not binding the two ends;
but never 2 or more rows!
<p>
I have posted a bug in Turbogears wiki, but the workaround was simple.
Just add "createRelatedTable=False" parameter to RelatedJoin's, create
explicitely the intermediate table classes, and invoke .createTable()
for them in some point. 
<p>
Since Luca creates all default identity rows while creating xuser
table, I take this opportunity to create the n-n tables in there, too.
<p>
<p>
Today the first table manipulation module (system users) was born. 
There are three main challenges here: choose an UI strategy, make all
pieces (HTML, CSS, Kid, Javascript and Python controller) sing together,
and generalize the module so all the next tables can inherit the 
basic functionality.
<p>
For UI, I have adopted a conservative strategy that resembles CTB way to
to tables: The main page of sys_users shows a user list, with "Edit"
buttons for every row, as well as a "New User" single button. Doing
an Edit gives access to data update form, as well as a "Remove" button.
<p>
The main difference from CTB are the AJAX touches. The add/edit/delete
form is hidden at the list page, and it is turned visible when Edit is
invoked. That avoids loading a whole new page. Before the form is shown,
it must be filled with the most recent data, that is fetched via
JSON remote request.
<p>
For Add/Edit submits, as well as row removing, I opted to keep the
traditional approach of doing a GET request that reloads the whole page,
since the row list must be updated anyway. I could try to update the
list using JSON, DOM swaps etc. but still the HTML table could be
rendered obsolete by concurrent users.
<p>
So now I only need to add some fine-grained checks, and make the
table manipulation a superclass. Other thing that I feel tempted to do,
is to add a fallback mechanism for users with old browsers. I am still
not sure that it is worth the time, though. I feel that people really
want neat applications and happily install the latest browser whenever
needed.
<p>
I must say again that is mind-twisting to work with all those languages
at the same time, but at the end it was actually fun :)
<p>
2006/06/24
<p>
My approach of using traditional page reloads for some operations proved
problematic. Since the update form and the table list are in the same
page, it becomes increasingly difficult to return error messages and
still keep the form open with data in place.
<p>
So, I have changed the from to be more fully AJAX. Except from list load,
all other operations are remote JSON calls. The page reload is always
an initiative from the client-side (that is, Javascript code). This
leaves everything in a more consistent state.
<p>
Another thing I have decided to do, is to offer a "lite" (non-AJAX)
version of the table. It is good for users that only have a crippled
browser, and it is a good test of code reuse within the Controller
class.
<p>
The lite version is now working, a Javascript-free version that should
run in any HTML 4 browser. Some tweaking in parameter lists and it
is working in record time.
<p>
In the AJAX version, I have added some eye-candies from CTB: Enter does
not submit the form, it changes focus to the next field. And the focus
field gets a yellow background (configurable in CSS). Actually the
functions from CTB were very crude, so I cleaned them up.
<p>
I ran into some String X Unicode problems. I had specified the string
columns as StringCol's in database, which made SQLObject get lost
in UTF-8 translations. Changing the database model to UnicodeCol 
in all fields, and changing the validators from String to Unicode
seemed to fix the problem. Again this stupid separation of regular
and Unicode strings in Python is crossing my way, as it did in
Python for Series 60...
<p>
Now, next step is to make the table manipulation functions general
to be reused in other tables. Javascript and controller are quite
straightforward to do; I will have to learn more about Kid templates
to make it subclass-like.
<p>
Other problem I have addressed: SQL exceptions.
<p>
SQLObject does *not* re-raise SQL exceptions as database-neutral exceptions.
The only exception is SQLObjectNotFound, which is actually not an "error"
in SQL level (SELECTs may return empty results, can' they?).
<p>
After some desperation, I discovered that
<p>
a) Python DBI implementations must implement a well-defined tree of exceptions,
   so, in the worst case, at least the exception classes' names would be
   predictable.
<p>
b) Better yet, SQLObject module has a "backend" property which refers to
   the DBI in use. So, the unpredictable flavor of (random_dbi).IntegrityError
   becomes just backend.IntegrityError which can be directly catched.
<p>
In order to insulate incompatibilities and classify the SQL exceptions
in three major types (not found, integrity error and "unexpected") I have
created tuple variables in model.py which are used by exception handlers.
<p>
2006/06/25
<p>
Today I have done most generalization work on Javascript and Controller 
sections, paving the way to allow a table manipulation superclass, and also
allowing the relocation of most Javscript functions to a general script
file.
<p>
The location of all table-specific information in a single point will
also make easier the future i18n effort, with the big exception
of Kid templates, which I still don't know how to i18n the best way yet.
<p>
2006/06/26
<p>
The generalized versions of Controller and Javascript functions have
been tested and debugged. 
<p>
I have removed all the
<pre>
onBla="ble(event)"
</pre>
<p>
attributes from HTML (that is, the Kid templates) and have moved all connection
to event handlers to Javascript. The only remaining Javascript hook
in the HTML is the "onLoad=ajax_setup()" that configures everything
else.
<p>
The connection to events is not done by regular Javascript API; I put
the Mochikit wrappers into use. They are nicer because they deal with
browser interoperability (event handling is among the biggest source
of incompatibilities between IE and Mozilla and the rest).
<p>
By doing event connection the Mochikit way, events received by functions
are not bare javascript event objects, but Mochikit wrappers which
uniformize the event attributes. Instead of having to test for
e.target (Mozilla) or e.srcElement (IE), you just call e.target().
<p>
<p>
Ok, the general part of Javascript ajax_* functions is a separate file
now. Every different table will need its own small Javascript file to
set the custom variables.
<p>
The table manipulation controller has also been "superclassed" as
simple_table, and User manipulation has become a subclass (which kept
the name sys_users). It was easier than expected. 
<p>
<p>
One "ugly" thing is that I had to @expose and @validate the 
subclass methods, not the superclass ones. I could not find a way
to express @validate(validators=variable_at_subclass), so I just
resorted to move all @validate's to the subclass.
<p>
The other ugly thing was the need to rename the superclass methods.
At the first time, I had un-@expose'd methods in the superclass, and
overrode them with @expose'd methods in the subclass:
<pre>
simple_table::lite_edit(...)

@expose sys_users::lite_edit(...)
	super(...).lite_edit()
	...
</pre>
<p>
No problem until now, but if the superclass happens to call a method
that had been overriden and @expose'd, we have problems, since the
@expose'd method returns a HTML page, and the caller was expecting
a dictionary:
<pre>
simple_table::fetch(...)
	# Fetches data from table
	...
	return row

simple_table::lite_edit(...)
	row = self.fetch(...) # expects a dictionary with row's data

@expose("json") sys_users::fetch(...)
	# Returns a row of data marshaled as JSON string
	super(...).fetch()
	...

@expose sys_users::lite_edit(...)
	super(...).lite_edit()
	...
</pre>
<p>
The simple_table::lite_edit() method will fail because it is inadvertently calling
the subclass' fetch() which does NOT return the expected dictionary. After all,
it is wrong for a subclass method to changes the superclass interface (in the case,
returning a JSON string instead of the dictionary).
<p>
My solution was to rename the superclass methods. It worked, but there may
be better ways:
<pre>
simple_table::_fetch(...)
	...

simple_table::_lite_edit(...)
	row = self._fetch(...)

@expose("json") sys_users::fetch(...)
	self._fetch()
	...

@expose sys_users::lite_edit(...)
	self._lite_edit()
	...
</pre>
<p>
This scheme guaranteed that _lite_edit() would obtain a dictionary from _fetch(), since
it is not being overridden. We also got rid of super(..) in the subclass, which may be
a good thing (lots of people do not like Python's super() thing).
<p>
Albeit ugly the solution works and brings an important advantage: a subclass may
choose to override _fetch() (or any other "private" method), if it wants to change
_fetch() behavior. As long as the subclass keeps the interfaces promised by the superclass,
nothing breaks.
<p>
Maybe the only ugliness of this scheme is to use underscores (my C++ old habits) instead
of giving more proper names to the methods. But that can be easily fixed anytime in the
future...
<p>
Now... we are ready to release the 0.1 version! w00t!

<? footer("/", "en"); ?>
