<? require "../lib.php"?>
<? aheader("Luca Development Diary - from 0.1 to 0.2"); ?>

<p>
29/06/2006

<p>
After having completed the users table manipulation via Web, I took a rest 
before continuing the work on it. 

<p>
The next logical step is to create the other table manipulation pages 
using the simple_table superclass. In this stance, I have create the 
following new pages:

<pre>
sys_cmos (system parameters)
stdjournals (standard journals)
costcenters (cost centers)
</pre>

<p>
All of them brought some new things that demanded improvements in the
superclass and/or the Javascript routines. First thing was 
the &lt;select&gt; fields. In the AJAX forms these fields are not a 
problem because the field.value property readily gets/sets the selected
option (at least in Mozilla; this is something to be very well tested
in other browsers). The problem was in the "lite" form: the selected
value must be pointed by a "selected" parameter in one of the daughter
*options*.

<p>
Since all three new tables have only True/False select fields, the
solution was kind of easy: put one Kid variable per option, reset
all to None, and set the ones you want selected. 

<p>
This trick needed a new overrided method in the simple_table: 
preedit2(). This method is called everytime a row is fetched or
resent. It is different from preedit() since preedit() is called
only once, when the row is fetched.

<p>
We need to rebuild all option variables every time the "lite" form
is transferred because, different from Javascript, setting the
"value" parameter of select does NOT fix the daughter options. So,
when the user makes a mistake and the same form data is resent
for the user to fix, selects would not reflect what the user chose
in the previous form.

<p>
So, in re-edits, preedit2() is called on data to rebuild the option 
variables, and the select will be the correct one (i.e. whatever the
user had chosen in the previous form).

<p>
Other issue is, standard journals and cost centers have no alternate ID,
and the ID is automatically attributed. So the user may add or change
a standard journal and being unable to find it just afterwards. It is
quite mandatory to show somewhere what was the ID of the just-added
row.

<p>
In the "lite" pages, it is not a problem because they already 
showed such messages using TurboGears flash(). The problem was
the Javascript version, where the page reload is commanded by
Javascript itself, not by the controller.

<p>
I fixed this by adding a "msg" in the _fetch and _remove responses.
the @expose'd methods for stdjournals and costcenters flash() these
messages without raising redirects. Hopefully when the Javascript
reloads the page, the pending flash() will be show. (I still need
to test this...)

<p>
30/06/2006

<p>
Well, the trick of flash()ing a message in a JSON controller method
did not work; the next page came with no message. But this was easy
to fix: I just put the message in a variable, and flash() this message
the next time index() is shown.

<p>
The rest of modifications worked right, so it's time to go on :)

<p>
I began to work on report calculation routines, to take a break from the
HTML/Javascripts. These functions showed me clearly where the SQLObject
model begins to do more harm than good. The standard SQLObject way of like
would be to do things in a crudely unoptimized way, essentially fetching 
all journals from SQL server, which is not good. 

<p>
The good news is that SQLObject allows easy employment of "raw" SQL
expressions when object-oriented way is not enough. So I could 
do the bulk of calculations via SUM()/GROUP BY in SQL side, and 
did the aggregate accounts summarization at Python side. 

<p>
19/07/2006

<p>
Wow, a lot of time without writing comments. I have been working in Luca
all these days, albeit in a slower pace due to personal problems. The
latest Luca news are the following:

<p>
- I have reached the conclusion that xclass.oid row is not needed. Account
reports should be ordered by account code anyway, so there is not point
in pre-grouping based on account class order. I did not remove the row
because it will be a pain to put it back should I change my idea again,
and it is harmless to leave it there.

<p>
- Charts and organizations table manipulation pages are in place. Slowly
but surely the pages get more complicated. In the case of organizations,
the charts selection handling was the "outstanding" element. Charts must
be checked very throughfully since an invalid/inconsistent change in
account chart may break all accounting reports, and user must be protected
from this.

<p>
- I also began to work on ACLs and security. I ended up with one function
that does authentication, ACLs and logging all in the same function, to
leave things the simplest possible to the client classes. Basically, the
client do something like:

<pre>
grant = permission(user, self, "write.add")
if grant.err:
	print "Error: ", grant.err
else:
	try:
		# do something
	except error:
		grant.fail()
	grant.done()
</pre>

<p>
So, basically, the permission checking function returns a log object,
and the only thing left for the caller is to call obj.done() to commit 
the log -- or call obj.fail() if transaction failed.

<p>
While ACLs were planned only for 1.1 version, the activity log was
planned from the beginning. ACLs will take a ride with logging it is
going to come a lot earlier than 1.1.

<p>
In order to test the log+ACL functions, I added log/authentication
for "parent X child" user administration tables (see below).

<p>
- SQLObject events

<p>
I was planning to move some high-level validation checking into model,
that is, to the SQLObject table objects. That would avoid a lot of
potentially duplicate code that is going into controllers now.

<p>
I would probably have to add another exception type, and handle that
exception in controllers, to get validation fails. But it is still
better than duplicating validation code.

<p>
The problem is, SQLObject 0.7 still did not have a event framework,
that is, some kind of overridable or callback methods that would be
called on add/update/remove and would leave a chance for checking.
SQLObject 0.8 will have that, but I am using the version that comes
with TurboGears - SQLObject 0.7. 

<p>
So, let's wait until TG gets the newest version to do this validation
refactoring. (It is on the TODO, I plan to to that as soon as possible.)

<p>
- As part of 0.2 release effort, I have completed three user administration
related controllers, users X groups, groups X permissions and users X
organizations.

<p>
All those 3 controllers are meant to manipulate "n by n" relationships
between tables. So they have no real data input, they are just a matter
of adding or removing relationships in the intermediate table.

<p>
These controllers were a lot easier to make than the others, in particular
because 99% of the behaviour could lie in superclass. 

<p>
For those, I did not use any AJAX or Javascript. The rationale is
1) they work well without them; 2) these controllers are not used
often, and only the administrator will use them, so they can be more 
"crude"; 3) I was lazy :) Anyway, nothing prevents us from adding
a AJAX version of these controllers in the future.

<p>
- TurboGears widgets. I am getting more and more interested in TG widgets,
since they brings ready-to-use solutions to difficult yet common 
challenges like autocompletion forms. I have been avoiding widgets
by will, since I want to learn TurboGears very well *before* using
such advanced features. But certainly there will be room for a lot
of refactoring in the future, replacing hand-made things with
forms.

<p>
- I have (re-)discovered a bug in MySQLdb. It is not raising IntegrityError
exception for some foreign key violations; it raises OperationalError
instead, which Luca interprets as a fatal SQL error, even sending a
desperate message to the user ("contact your system administrator!").

<p>
I went to MySQLdb project page and could see that this bug had already
been reported. I just added a comment reporting all possible MySQL errors
that should raise IntegrityErrors, and that was the right thing to do;
the maintainer answered that two of them were still not being raised as
integrity errors. 

<p>
As usual, I mentioned this problem in Luca's README, with a (tested) patch 
that solves the problem. Anyway, I expect that next MySQLdb versions come
with this bug fixed and I can remove this from README in some point of the
future.

<p>
This release will be a bit buggy, since I am having more fun implementing
things than testing them throughfully. Maybe I should begin to think
about testing routines... Anyway, the most difficult bugs arise in the
Javascript-controller communication, and I have no idea how to exercise
Javascript and HTML pages automatically :(

<? footer("/", "en"); ?>

