<? require "../lib.php"?>
<? aheader("Luca Development Diary - from 0.4 to 0.45"); ?>

<p>
2006/09/28

<p>
Whoa, lots of refactoring in the last days. The next days promise to be challenging
because all modifications need to be tested ad nauseam.

<p>
I have made tons of cosmetic changes, but the main one is to realize that we can no 
longer handle only "data rows" coming from and being sent to form templates. The
rigid 1:1 mapping between data rows and forms used to work, but demanded lots of
tricks to workaround the exceptional details, like a field that lies in the form but
is not saved to the SQL table and so on.

<p>Another case that showed the need of better data representation, was the
date fields of the active_period control. Date/time colums are neither strings
nor integers, they are "special" and need business logic to be converted 
(Turbogears validators did not suffice). 

<p>
So, now we have three types of data "objects" (in truth they are dictionaries):
ROWS, INTERMEDIATES and FORM_DATA. Rows are 1:1 mappings to SQL rows, they can
be directly saved or loaded from SQLObject rows. Note that a row element is not
a SQLObject object, it is a dictionary. Intermediates are the "native" representation
of a row plus exceptional data that is validated and manipulated by controllers.
And finally the form_data dictionaries that are offered to Kid templates.

<p>When a form is submitted (either via AJAX or via regular form submit), 
TurboGears first validates the form data and calls a controller function
passing a form_data dictionary as parameter. Note that TurboGears guarantees
that this form_data is already checked to great extent; integer fields are
already converted from string; missing fields will raise an ugly Turbogears exception etc.

<p>The form_data is converted to the intermediate format simply by copying the
elements, but the controller can extend or modify this behaviour by overriding
the form_to_intermediate_ext() method. Then, intermediate_validate() is called to
do the fine-grained validation of the data. When it is time to save the data, 
intermediate format is converted to a row, and again the controller can
override intermediate_to_row_ext().

<p>The data flows from SQL to form in a similar way. The controllers have the
opportunity to intervene in the process by overriding row_to_intermediate_ext(),
intermediate_to_form_ext() and auxiliary_form_data(). (The last method is called
only when a new form is loaded, not for AJAX calls).

<p>Another serious problem was the plugging of business logic on remove and
update events. Such logic was being plugged in a disorganized way. I have
added a new mechanism for that: triggers. Unfortunately SQLObject still does
not support triggers, so we need to creat our own trigger protocol.

<p>The controllers that inherit from single_table (almost all of them ultimately
inherit from it) can override any of the following methods: trigger_remove_pre(),
trigger_remove_post(), trigger_update_pre() and trigger_update_post(). The
"pre" triggers can avoid the operation by returning an error. The "post" 
triggers cannot return errors since the operation is already done, but an
SQL exception rollbacks the whole operation (so it effectively can cancel 
the operation, even though wouldn't be the "right" place to do so). 

<p>
The simple_table class had quite an abuse of variable parameter lists. It was
fueled both by the TurboGears form parameter passing (exposed methods need to
receive a variable parameter list, since unexpected variables are sent), and
by the fact that SQLObject receives row data that way. I did a heavy cleanup
in simple_table, so no method accepts a variable parameter list anymore. This 
will also help in debugging the whole system and creating the test cases.

<p>
Another incredibly ugly thing was the pervasive use of _methods _that _began
_with _underline. I have renamed almost all of them to better and more obvious
names, with immediate improvement of code legibility.

<p>
A thing that I wanted to get rid of, but I couldn't do much, was about the 
redirects that are employed in controllers. The most infamous example is 
the lite_commit() exposed method: it receives a form submit that inserts
or updates a data row in an AJAX-less form. If the update is succesfull, 
the method raises a redirect(). If the update is *not* successfull, the
function returns normally.

<p>
I could not find a better alternative. For the method to return in a normal way
when the operation succeeds, it would need to expose the "index" Kid template.
If the user clicked Reload on that page, it will run lite_commit() again with
missing parameters, throwing an ugly error in screen. The redirect solution
is ugly in the code but it is perfectly right when seen from the Web browser
side.

<p>
I am still not happy with this and other redirect()s around the system. I
will keep thinking about how can we reduce their need. A final point about
this problem is that most redirect() uses are in "lite" forms, which are
a Plan B feature anyway.

<p>
2006/10/02

<p>
Most of the refactoring is done, and some controllers have been tested. I am 
quite surprised to see how easy was to fix the first errors and make them
work again, the anedoctal evidence that the changes were much needed and 
resulted in better code after all.

<p>
2006/10/03

<p>
The refactoring goes on. I have decided to release a 0.45 intermediate version
with all refactorings but without any new controllers. The new code is so better
that I am shamed of the 0.4 version and I want to hide it as soon as possible :)

<p>
A thing that I had forgotten completely is the checkdigit for account codes. They
are important because account codes are long and look almost the same.
It is very easy to mistype an account code in a journal, an error that is difficult
to detect afterwards.

<p>
Funny things is that I had forgotten checkdigits in the former PHP-based system.
And now I have forgotten them again. Now it is fixed, checkdigits are in place.
There is a system-wide configuration parameter that regulates whether account
codes should be typed with or without checkdigits. 

<p>
Note that checkdigits are never stored in the database, and are not typed when
the account itself is created. It is simply a measure to reduce journal typing
errors. 

<p>
Another possible solution could be to employ short, digit-checked, automatically
generated codes. The user can type either the long code or the short code. This
would increase both typing speed and error checking.

<p>I chose not to support short account codes (for now) because I feel that 
personal accounting users will never know codes by heart; they will always search
each account by its name, so the code length does not matter, since it is never
typed in journals. In real businesses, journals are seldom typed; they are likely
generated automatically form other ERP modules. In short, the speed typing gains
of short codes will likely not materialize in day-to-day accounting.

<p>
2006/10/04

<p>
Today I began to write the test cases. While I don't expect to have them ready
for 0.45 release, but it is nice to have them in mind for the development roadmap
ahead.

<p>One important piece of test cases is already in place: the set of data samples
that will feed most automated tests. Things like correct data rows, invalid columns
that should trigger errors etc. Since most controllers are direct subclasses of
simple_table, most tests should be drop-in compatbible with most controllers, 
reducing the need of coding per-controller specific tests. Let's see if that
will materialize in practice...

<p>
2006/10/05

<p>
An old problem appeared again: Unicode handling. I had updated TurboGears
to 1.0b1 and during the tests I could see that encoding problems were back.
At first glance, seemed that it would be sufficient to pass an encoding
argument to database DBI, but this only makes the problem to move a bit
forward in SQLObject code.

<p>
For now I have decided to test without any non-ASCII characters, and handle
this problem afterwards (promises to be a difficult one).

<p>
2006/10/06

<p>
I have downgraded the SQLObject version to the TurboGears 0.9a6 level and the
Unicode problem went away. Next time I will update TurboGears in only one
machine and test the system before upgrading all environments. This is something
I will need to investigate more soon (in 0.5 release timeframe).

<p>
Today I finished testing all changes made for 0.45 version, so I can release
it. The code is far better than version 0.4. I have found some new bugs and
improvement opportunities but left them all for 0.5 release since I really
rushing 0.45 to public release.

<p>
During moments of laziness (nobody likes to test things ;) I progressed in
automatic test coding. It is not ready yet (maybe it will be for 0.5) but the
outline is quite clearly defined, it is now a matter of filling the gaps.


<? footer("/", "en"); ?>

