<? require "../lib.php"?>
<? aheader("Luca Development Diary - from 0.5 to 0.6"); ?>

<p>2006/11/11

<p>I have decided to split the release comments in two parts: the changelog
that is more technical and terse (and more important for anyone that is
actively following the system development), and this diary that is a space
for longer and more subjective discussions. 

<p>
It has been a lot more comfortable and rewarding to work on Luca 0.6.
Since the heavy refactoring in 0.45, the system as a whole feels a lot
more flexible and logic. This makes all improvements to fit easily
on top of the existing code. 

<p>Another helper was the completeness of
0.5 release;  all basic function points work (may not be incredibly
beautiful or practical for fast data entry, but they are usable),
and I could port data from my old PHP-based accounting system (CTB),
so now I have a true database to exercise Luca.

<p>0.6 release brings some new route changes (but not as many as
0.45 and 0.5 did). The main one is that I am freezing the database
as of 0.6, not at 0.8 as originally planned. I feel that a database
freeze is important if Luca wants to have any chance of being
used or developed by third parties.

<p>Database freeze does NOT mean that it won't change in the future;
we even have scheduled database changes in 1.2 release. The freeze
means that all database changes must be carefully weighted, documented
in changelog, and ideally applied automatically when a new Luca
version is installed.

<p>To achieve the database freeze right now, I had to add some 
database columns in data model right now, and put them into use.
For example, the long-standing question of where the locale 
configurations should be stored had to be settled: they are
stored as *user* configurations.

<p>Version 0.6 has no major changes, it is a big collection of small
improvements over a working version, most of the changes are UI-related.

<p>The journal entries controller deserved the biggest attention in
UI improvements since it is the page the user most often sees and uses.
The data entry form now has debit and credit accounts, as most systems
do. The first version that accepted only one of the journal legs at a
time was too primitive, I couldn't bear it even for my personal usage :)

<p>Another very important change in journal entry, invisible to the user, is the AJAX loading
of the chart of accounts. It has three important functions: reduces the reloading
time of the index page (since the full chart, which is often very long, will not come
embedded in HTML), and the chart is reloaded if some other user
changes that (thanks to the "version" column in charts table that is
kicked up at every update). The chart will be reloaded even if the
user is furiously adding journals one after another and never reloading
the page. Finally, having the list at client side allows fast filtering.

<p>A change that affected all AJAX controllers was the "throbber",
an animated GIF image that is shown when an AJAX transaction is flying.
It gives a feedback to the user, particularly important if the system
is being acesssed from the Internet where every AJAX transaction has a
long delay.

<p> All AJAX forms also show informative (blue) messages in the form,
not only errors in red. It is thought to give better user feedback.

<p>An internal important change was the allowing of different account classes
in a chart hierarchy line. For those that don't know, some businesses 
(notably banks) position the income/expense accounts below the Equity
accounts tree. It allows that the balance is permanently even (assets =
liabilities + equity), since the unbalance that would come from income/expense
accounts are already being aggregated inside equity.

<p>My former PHP-based system did not allow mixing accounts of different classes,
and so did Luca. But I felt this was an unnecessary limitation of a brand-new
system. So, now this mix is allowed. The only restriction is that non-aggregate
accounts must be of the same class as their immediate parent; the aggregate
account may then depart from its own parent's class.

<p>2006/11/15

<p>
The auto test routine took more than its fair share of time to get debugged,
something about 3 or 4 whole sessions of free software night work :) The most
time-consuming problem was not my fault; TG really lacks a way to change 
the current user from within the test routine. 

<p>By asking in #turbogears IRC channel, I was pointed to two different
solutions to this problem. One was basically a browser simulator that
first authenticated against TG pretty much like a human user. The other
one adds a function to testutil and a trick in each identity provider
(soprovider and saprovider) so the test routine can impersonate an user
by just calling a function and change as often as it wants. I chose the
latter even though it depends on a TG patch (ticket #1166) that is going
to be integrated into TG 1.0 final.

<p>
Since the tests depend on that patch, it is not meant yet for the user to run
it when he installs Luca; it is meant only for developers (this means myself
as long as I don't have collaborators to help me :) The tests are still
quite incomplete, they only test the "simple" tables about adding/updating/removing
rows. It still does NOT test:

<ul>"Lite" requests (because of the need to decode HTTP responses)
<li>Two-level tables and three-level tables: charts_accounts, batches and journals. 
<li>"Index" screens of all controllers (HTTP decoding)
<li>Reports (HTTP decoding)
<li>reportlib library, that calculates the reports. (Will need a known data set to compare against)
<li>Log queries (HTTP decoding)
</ul>

<p>Another thing that does not work in TG in test model is the cherrypy.session
persistent data. The very cause is there is no session during the test; it is related
to the problem of user identity during testing: TG refused to login an user in test
by regular means (e.g. by a createRequest("/login", ...)) because there was no 
session set up.

<p>
Still, the present test version already caught a handful of bugs including
two important permission/related ones, so it pays off, as every Python programmer
should know well.

<p>
About the migration from CTB to Luca. I have exercised the conversion routine 
several times as well the Luca reports, and everything seems fine to migrate
to the new system in this month. My smartphone has already been updated to LucaMobile,
so I can't use it to book my daily expenses until I migrate, so it needs to happen
soon :)

<? footer("/", "en"); ?>

