<? require "../lib.php"?>
<? aheader("Luca Development Diary - from 0.65 to 0.7"); ?>

<p>
2006/12/25

<p>
Merry Christmas! Santa Claus brought a new toy: a Mac Mini. The Sacred Apple is again blessing
my network! I had a PowerPC iBook in the past, so I already tasted the great hardware Apple
does. I sold it because I hadn't had much use and I don't like to see my equity trapped in a
interest-less investiment. I work with Linux for a living and Linux means i386; using 
Linux on PowerPC "works" but means spending time in non-profitable tasks like trying to
make the devices work etc. Now Macs are i386 and are twice as useful for me.

<p>
As a die-hard Linux user, I did the Boot Camp pathway and installed Linux (still demanded a
small trick related to GPT x MBR partition tables; in six months all distros should be 
installing completely flawlessly). My primary intention was to use Linux most of the time,
but the temptation of migrating more and more tasks to Mac OS X soon grew. And of course
porting Luca to Mac OS X was the most tempting thing to do.

<p>
After about an afternoon of work, counting the installation of all needed packages 
(MacPython, MySQL server, etc.) and some problems to recompile Python-MySQLdb (the solution
was to compile it statically). The Unicode versus UTF-8 problem demanded yet another
patch in MySQLdb (which is included in the README.txt now). All in all, it worked
easily considering that it really is a different operating system. 

<p>
From now on, I can say that Luca is officially ported to Mac OS X, since I will have been
using it in Mac OS X, while doing most of the development in Linux. Next challenge is
to port Luca to Windows :)

<p>
2006/12/26

<p>
Improvements in AJAX in-place update of rows. The charts of accounts page has been
improved to actually receive formatted column data from the application server.

<p>
This means that the formatting code does not lie in Kid templates anymore; it is
in Python server, so AJAX transactions can also benefit from them. Even though
only one page has been "upgraded", the interface has been defined and all other
pages are going to be changed to follow this guideline.

<p>
The most difficult part -- the Javascript in-place update routines -- are already
"generic" so it should be quite easy to upgrade all other AJAX pages to behave
the same way.

<p>
2006/12/28

<p>
More sacrifices to the sacred apple today! LucaMobile got server support for Mac OS X,
so now I can again use my cell phone to log day-by-day expenses and upload to the Mac.

<p>
I had already thought of supporting Mac OS X as a server in my old accounting system
(LucaMobile inherits almost all its code from that old system). It was January 2006,
I learnt about PyObjC and Cocoa Bluetooth libraries but did not put both to work 
together. Eventually I sold my iBook and was no longer interested in Mac support.

<p>
Now I have a Mac again, and today I thought that perhaps someone had put together
some PyObjC-Bluetooth sample code and make my life easier. Surprise, I found something
even better: a complete platform-neutral Bluetooth library that supports Mac OS X --
<a href="http://lightblue.sourceforge.net">LightBlue</a>. 

<p>
First I thought about learning from LightBlue's code and copying selected parts into
LucaMobile, but LightBlue implements some calls in Objective C -- things related to
service publishing (exactly what I wanted). I wouldn't like to add C/ObjC/C++ code
into Luca... so I found it better to use LightBlue and let it go.  The downside is 
that someone that wants to try LucaMobile on Mac OS X must also install LightBlue.

<p>
I could convert all other LucaMobile platform-specific modules to depend on LightBlue
only, effectively transferring the portability problems to LightBlue, but I would not
like to mess with code that is proven to work right, and LightBlue allows some
platform-dependent quirks to leak to the application (e.g. the exceptions' classes).


<p>
2006/01/07

<p>
I have received a very nice gift from my manager: a dictionary of accounting terms,
in English. This was the ultimate tool that I needed when I *began* to work on Luca.
All in all, the overall level of English terms in Luca was not so bad, and I just
found a half dozen things that badly needed a fix. As time goes by I will review
page by page against the dictionary and catch more translation problems.

<p>
I made an extensive revision of the installation process described in the README.
That document asked for several patches being done directly on the Python code of
some libraries like MySQLdb and SQLObject. I thought that maybe some of that fixes
wouldn't be necessary anymore, given the latest versions of TurboGears and other
tools.

<p>
Some fixes were indeed obsoleted by the newest version of MySQLdb (1.2.2-beta2),
those ones related to integrity errors raising the right exception. This was the
most problematic fix because it demanded to change a C source file in MySQLdb and
of course do a recompilation. 

<p>
A problem that still exists is the Unicode conversion problems. Curiously, part of
the solution I proposed in README was incorporated in MySQLdb 1.2.2 so the user
may install that version of MySQLdb and save himself from some problems. 

<p>
Unfortunately, there still are problems in SQLObject-MySQLdb interfacing, so the
manual fix on SQLObject is still needed. Otherwise, all combination of "charset"
and "sqlobject_encoding" parameters passes in the database URI will render problems:
either they do not encode when go to the database, or decode twice then data *comes*
from the database. What I do in Luca is basically disable all conversion and let
UTF-8 strings flow directly from the pages all the way down to the database. 

<p>
The source of this problem is curious: both SQLObject and MySQLdb tried to offer
a better API for unicode strings, and they changed their APIs almost by the same
time, but without coordination between them, causing the double-encoding problems.
(SQLObject 0.8 promises to fix this in the future.)

<p>
Another manual intervention in SQLObject that is still needed is the creation
of tables with foreign key columns in MySQL. SQLObject 0.7 is aimed to MyISAM
backend that does not have those features. SQLObject 0.8 will "know" that some MySQL
backends are capable of doing foreign keys.

<p>
Anyway, the new README is quite shorter than last version.

<p>
In this process of (trying to) removing Unicode tricks that are no longer needed,
I discovered that UnicodeString form validators will now discover the character
set from the Web page, so it is no longer needed to pass a hardcoded "utf-8"
charset parameter. A good sign that Turbogears/Unicode issues are really being
looked upon and fixed.

<p>
Now all AJAX pages support in-place updating without need to reload. The
accounts of the chart page already supported this feature so it was a matter
of making the same changes in the other Kid templates. It worked more readily
than I could have imagined, another sign that the generalization efforts in
Luca code are still paying dividends. 

<p>
In the other hand, the Kid templates are getting more boring to maintain and
more prone to be out of sync, so I begin to envision some meta-template scheme
that generates the boring parts of all templates from a small handful of 
specific per-page data.

<p>
Another feature related to the in-place update is the handling of concurrent
access. For example, if two users are editing the same table, it is dangerous
to do in-place updates because both will be seeing obsolete data. In this case,
the page should be fully reloaded.

<p>
So we added a "version control" system for almost all tables. Some tables already
had it (standard journal entries, cost centers and charts of accounts) because
those tables are kept synchronized with mobile clients and they already needed
version control in the past, and the same control allows concurrent access
detection.

<p>
The most painful decision was whether to add columns to the database or not.
In the end I dediced to add them because putting this control in the database
level will allow for concurrent access handling even if non-Luca software is
manipulating the database (lucamobile for example accesses the database without
help of Luca or SQLObject, so it can be considered an "external" software).

<p>
Since I consider the database "frozen" and any change in database should have an
easy way for the Luca user to upgrade its own database with minimal effort,
I had to create a script that tested the database version and changed the tables
accordingly. The final result (update_database script) was very simple yet
effective.

<p>
For every controller that inherits from simple_table.py, there can be an
inherited method called "table_version" that returns a monotonically increasing
version number. This number is sent to the client when it reloads the page
and also along with any AJAX transaction, so the client can monitor if the
version is above the expected, which means that another client changed the same
data set that he is seeing.

<p>
The version bumping is done in trigger_update_post and trigger_remove_post
overridable methods. I added some functions to the model classes in order
to reduce the code duplication in controllers, and centralize future version
control modifications in the model, leaving the controllers alone. (Of course
that the best place for the version bumping would be a SQLObject trigger
[only in 0.8 version] or in a database trigger [that I avoid to use since
not all databases support it]).


<p>
2006/01/19

<p>
Three news today:

<p>
a) 0.7 version is out. I would like to put more features in this release, but
it is quite well-rounded and I am willing to publish it because of (b)

<p>
b) I have contracted a <a href="http://www.rimuhosting.com">RimuHosting</a>
VPS hosting. While it is just a Xen virtual machine, it gives you all the
freedom and advantages of having full control of a network server. I was
missing the joy (and the exercise) of system administration. And the
most important: it will allow for people to try Luca on-line without even
having to download/install it.

<p>
c) I quit trying to make Luca work on Internet Explorer, at least for the
short-term future. IE6 does not have a Javascript debugger, which left me
completely in the dark when the first things began to break (yet, some
things like live row updates work). Also, basic things like CSS :focus did not work.
Since Firefox is so ubiquitous these days, and I already support Safari as
a second option, I quit on this. If someone wants to work on this, will be
welcome :)

<? footer("/", "en"); ?>


