import lightblue
import _socket
from threading import Thread
import select
import time
import urllib

exceptions = ( lightblue.BluetoothError, )
exceptions_nonfatal = ( _socket.timeout, )

ctbname = "CtbSyncService"
terminator = "\t\t\t\r\n"
running = 1

class bconnection(Thread):
    def __init__(self, conn, addr):
	Thread.__init__(self)
	self.sk = conn
	self.addr = addr

    def run(self):
	print "Handling connection from %s" % str(self.addr)
	phase = 0
	buffer = ""
	ping = time.time()

	while running:
		if (time.time() - ping) > 60:
			print "Bail out %s" % str(self.addr)
			break

		print "Bconnection select"
		if phase == 0:
			r = [self.sk]
			w = []
		elif phase == 1:
			r = []
			w = [self.sk]
		
		try:
			r, w, e = select.select(r, w, [], 1)
		except:
			print "Bconnection closed unexpectedly %s" % str(self.addr)
			break

		if r:
			ping = time.time()
			try:
				s = self.sk.recv(4096)
				if not s:
					print "Bconnection closed unexpectedly %s" % str(self.addr)
					break
				buffer += s
			except:
				print "Bconnection closed unexpectedly %s" % str(self.addr)
				break

			if terminator in buffer:
				phase = 1
				print "Bluetooth request: %s" % buffer
				# using this technique avoids all threading problems of calling cherrypy methods directly
				params = urllib.urlencode({'blob': buffer})
				f = urllib.urlopen("http://localhost:22222/remote_mobile?%s" % params)
                       		buffer = f.read()
				buffer += terminator # fools get_data() 
				print "Bluetooth response: %s" % buffer

		if w:
			ping = time.time()
			try:
				l = self.sk.send(buffer)
			except:
				print "Bconnection closed unexpectedly %s" % str(self.addr)
				break
			if not l:
				print "Bconnection closed unexpectedly %s" % str(self.addr)
				break
			buffer = buffer[l+1:]

			if not buffer:
				print "Ready to next request"
				phase = 0

	self.sk.close()
	print "Extinguished conn %s" % str(self.addr)
			

class server(Thread):
    def __init__(self):
	Thread.__init__(self)

    def run(self):
	time.sleep(1)
	sk = lightblue.socket()
	sk.bind(("", 0))
	sk.listen(1)
	lightblue.advertise(ctbname, sk, lightblue.RFCOMM)
	print "Listening Bluetooth"

	while running:
		r, w, e = select.select([sk], [], [], 1)
		if r:
			conn, addr = sk.accept()
			if conn:
				bconnection(conn, addr).start()

	sk.close()
	print "Bluetooth server extinguished"
