import logging
import time

import cherrypy

import turbogears
from turbogears import controllers, expose, validate, redirect
from turbogears import identity

from sqlobject import *

from luca import json, sys_users, sys_password, sys_groups, sys_classes, stdjournals, costcenters, sys_cmos, charts, orgs
from luca import sys_usersXgroups, sys_groupsXperms, sys_usersXorgs, sys_qlogs, active_period, charts_accounts, currencies, currency_rates
from luca import batches, journals, report_balance, report_ledger
from luca import report_income, report_incomeavg, report_cashflow, report_journal
from luca import balance_closing, remote_mobile

from luca.scheduler_tasks import add_all_tasks, run_startup_tasks

import mylib
import model


turbogears.startup.call_on_startup.append(run_startup_tasks)
turbogears.startup.call_on_startup.append(add_all_tasks)

turbogears_log = logging.getLogger("luca.controllers")

class Root(controllers.RootController):

    sys_users = sys_users.sys_users(turbogears_log)
    sys_password = sys_password.sys_password(turbogears_log)
    sys_usersXgroups = sys_usersXgroups.sys_usersXgroups(turbogears_log)
    sys_groupsXperms = sys_groupsXperms.sys_groupsXperms(turbogears_log)
    sys_usersXorgs = sys_usersXorgs.sys_usersXorgs(turbogears_log)
    sys_groups = sys_groups.sys_groups(turbogears_log)
    sys_classes = sys_classes.sys_classes(turbogears_log)
    sys_cmos = sys_cmos.sys_cmos(turbogears_log)
    stdjournals = stdjournals.stdjournals(turbogears_log)
    costcenters = costcenters.costcenters(turbogears_log)
    charts = charts.charts(turbogears_log)
    charts_accounts = charts_accounts.charts_accounts(turbogears_log)
    currencies = currencies.currencies(turbogears_log)
    currency_rates = currency_rates.currency_rates(turbogears_log)
    batches = batches.batches(turbogears_log)
    journals = journals.journals(turbogears_log)
    report_ledger = report_ledger.report_ledger(turbogears_log)
    report_balance = report_balance.report_balance(turbogears_log)
    report_cashflow = report_cashflow.report_cashflow(turbogears_log)
    report_journal = report_journal.report_journal(turbogears_log)
    report_income = report_income.report_income(turbogears_log)
    report_incomeavg = report_incomeavg.report_incomeavg(turbogears_log)
    orgs = orgs.orgs(turbogears_log)
    active_period = active_period.active_period(turbogears_log)
    balance_closing = balance_closing.balance_closing(turbogears_log)
    remote_mobile = remote_mobile.remote_mobile(turbogears_log)

    sys_qlogs = sys_qlogs.sys_qlogs(turbogears_log)

    test_flags = ()
    vips = []

    def perm_org(self, interm):
	return 0 #pragma: no cover

    def test__index(self, t): #pragma: no cover
	t.cargo = t.tu.call(self.menu)
	return True

    def test__index_lite(self, t): #pragma: no cover
	t.cargo = t.tu.call(self.menu_lite)
	return True

    def test__run(self, t): #pragma: no cover
	t.C = self
	t.logmask = t.DENIED + t.DONE + t.FAIL
	if not t.permission_granted("r00t", self.test__index, t.DONE):
		t.fail("r00t")
	if not t.permission_granted("r00t", self.test__index_lite, t.DONE):
		t.fail("r00t lite")


    @identity.require(identity.not_anonymous())	#pragma: no cover
    @expose()					#pragma: no cover
    def index(self):				#pragma: no cover
	x = model.session()			#pragma: no cover
	if x['lite']:  				#pragma: no cover
		raise redirect("/menu_lite")	#pragma: no cover
	raise redirect("/menu")  		#pragma: no cover

    @identity.require(identity.not_anonymous())
    @expose(template="luca.templates.menu")
    def menu(self):
	x = model.session()
	x["lite"] = 0
	return dict()

    @expose()  #pragma: no cover
    def lite(self):  #pragma: no cover
	raise redirect("/menu_lite") #pragma: no cover

    @identity.require(identity.not_anonymous())
    @expose(template="luca.templates.menu_lite")
    def menu_lite(self):
	x = model.session()
	x["lite"] = 1
        return dict()

    @expose(template="luca.templates.fincalc") #pragma: no cover
    def fincalc(self):  #pragma: no cover
        return dict() #pragma: no cover

    @expose(template="luca.templates.login")  #pragma: no cover
    def login(self, forward_url=None, previous_url=None, *args, **kw): #pragma: no cover
        if not identity.current.anonymous and identity.was_login_attempted() and not identity.get_identity_errors(): #pragma: no cover
            raise redirect(forward_url) #pragma: no cover

        forward_url=None #pragma: no cover
        previous_url= cherrypy.request.path #pragma: no cover

        if identity.was_login_attempted(): #pragma: no cover
            msg=_("The credentials you supplied were not correct or did not grant access to this resource.") #pragma: no cover
        elif identity.get_identity_errors():  #pragma: no cover
            msg=_("You must provide your credentials before accessing this resource.") #pragma: no cover
        else: #pragma: no cover
            msg=_("Please log in.") #pragma: no cover
            forward_url= cherrypy.request.headers.get("Referer", "/")
        cherrypy.response.status=403 #pragma: no cover
        return dict(message=msg, previous_url=previous_url, logging_in=True, original_parameters=cherrypy.request.params, forward_url=forward_url) #pragma: no cover

    @expose() #pragma: no cover
    def logout(self): #pragma: no cover
        identity.current.logout() #pragma: no cover
        raise redirect("/") #pragma: no cover

