/*
 * AJAX-Functions to trigger foreign exchange rate download and display
 * result log
 */


/*
 *
 */
function parse_form(fields) {
    var params = [];
    for (var i=0; i<fields.length;i++) {
        var control = $('download_rates_form')[fields[i]];
        if (control.type == 'checkbox') {
            value = control.checked;
        } else {
            value = control.value;
        }
        if (value !== null) {
            params.push(fields[i] + '=' + encodeURI(value));
        }
    }
    if (params) {
        return params.join('&');
    } else {
        return '';
    }
}

/*
 * Display result log or error messages
 */
function ajax_download_rates_gotdata(rres) {
    ajax_throbber_end();
    ajax_pending = false;
    if (rres["err"]) {
        swapDOM("ajax_msg", PRE({"id": "ajax_msg", 'class': 'error_msg'},
          rres['err'].join("\n")));
    }
    else if (rres["msg"]) {
        swapDOM("ajax_msg", PRE({"id": "ajax_msg", 'class': 'status_msg'},
          rres['msg'].join("\n")));
    } else {
        swapDOM("ajax_msg", DIV({"id": "ajax_msg", 'class': 'error_msg'},
          "AJAX message result malformed"));
    }
    setElementClass("msgdiv", "shown");
}

/*
 * Trigger FX rate download
 */
function ajax_download_rates(ev) {
    if (ajax_pending) {
        return;
    }

    replaceChildNodes("ajax_msg", null);
    ajax_hide();
    ajax_throbber();

    var addr = ev.target().form.action + '?' + 'tg_format=json';
    var params = parse_form(["code", "startdate", "enddate", "keep_manual"]);
    if (params) {
        addr += '&' + params;
    }

    var ajax = loadJSONDoc(addr);
    ajax.addCallbacks(ajax_download_rates_gotdata, ajax_error_hide);

    ajax_pending = true;
    if (ev) ev.stop();
    return false;
}

/*
 * Show form when toggle link is clicked
 */
function formdiv_toggle(id, show) {
    var formdiv = $(id + '_div');
    var toggle = $(id + '_toggle');
    if (typeof(show) == 'undefined') {
        var show = hasElementClass(formdiv, 'hidden');
    }
    if (show) {
        setElementClass(formdiv, 'shown');
        replaceChildNodes(toggle, '<<');
        setElementClass(toggle, 'shown');
    } else {
        setElementClass(formdiv, 'hidden');
        replaceChildNodes(toggle, '>>');
        setElementClass(toggle, 'shown');
    }
}

/*
 * Add callbacks on page load
 */
connect(window, 'onload',
    function() {
        connect('download_rates_form_submit', 'onclick', ajax_download_rates);
        formdiv_toggle('download_rates_form', false);
        connect('download_rates_form_toggle', 'onclick',
            function(ev) {
                formdiv_toggle('download_rates_form');
                ev.stop();
            }
        )
        formdiv_toggle('import_currencies_form', false);
        connect('import_currencies_form_toggle', 'onclick',
            function(ev) {
                formdiv_toggle('import_currencies_form');
                ev.stop();
            }
        )
    }
);

