import cherrypy

import turbogears
from turbogears import controllers, expose, validate
from turbogears import identity, validators

from luca.model import xgroup, xpermission, group_permission, conn, notfound, denied
from luca import model

from luca.parentXchild import parentXchild

class sys_groupsXperms(parentXchild):

# SUBCLASS-SPECIFIC FUNCTIONS AND PARAMETERS ##########################################################
	
    validators = {"select_parent": validators.Int(if_invalid=0),  \
		  "parent_now_id": validators.Int(if_invalid=0), \
		  "button_add": validators.UnicodeString(if_invalid=u""), \
		  "button_del": validators.UnicodeString(if_invalid=u""), \
		  "button_select": validators.UnicodeString(if_invalid=u""), \
		  "available": validators.Set(if_invalid=[]), \
		  "employed": validators.Set(if_invalid=[]) }
				 
    def setup(self):
 	   self.msg_unexpected = "ERROR: unexpected SQL error. Contact the system administrator"
	   self.msg_notfound = "Group not found, probably it has just been deleted"
           self.msg_updated = "Group has been updated"
           self.msg_validation_crash = "Unexpected validation error: notify system administrator!"
           self.msg_validation = self.msg_validation_crash
	   self.parent_table = xgroup
    	   self.child_table = xpermission
    	   self.cross_table = group_permission
    	   self.add_child_method = self.parent_table.addXpermission
    	   self.del_child_method = self.parent_table.removeXpermission
    	   self.parent_name = "group_name"
    	   self.child_name = "permission_name"
    	   self.parent_order = self.parent_table.q.group_name
    	   self.child_order = self.child_table.q.permission_name
     	   self.no_parent = "(None - please select an group)"
     	   self.parent_children_property = "permissions"

	   # special ACL that is accepted as valid permission
	   self.vips = ["ADMIN"]

    def check(self, parent_now_id, employed, available, action):
	# Ensures that admin (id == 1) never loses the "*" (g0d, id=1) permission
	# This should *REALLY* belong to model.py, how I miss sqlobject events ...
	if parent_now_id == 1 and action == "remove":
		clean = False
		while not clean:
			for i in range(0, len(employed)):
				if employed[i] == 1:
					del employed[i]
					break		
			else:
				clean = True
	return ""

# EXPOSED METHODS ########################################################

    @expose(template="luca.templates.sys_groupsXperms")
    @validate(validators=validators)
    def index(self, select_parent=0, parent_now_id=0, employed=[], available=[], 
			button_add="", button_del="", button_select="", **garbage):
        return self.base_index(select_parent, parent_now_id, employed, available,
				button_add, button_del, button_select)

    @expose(template="luca.templates.sys_groupsXperms_lite")
    @validate(validators=validators)
    def lite(self, select_parent=0, parent_now_id=0, employed=[], available=[], 
			button_add="", button_del="", button_select="", **garbage):
        return self.base_index(select_parent, parent_now_id, employed, available,
				button_add, button_del, button_select)

