import cherrypy

import turbogears
from turbogears import controllers, expose, validate
from turbogears import identity, validators

from luca.model import xuser, orgs, user_org, conn, notfound, denied

from luca.parentXchild import parentXchild

class sys_usersXorgs(parentXchild):

# SUBCLASS-SPECIFIC FUNCTIONS AND PARAMETERS ##########################################################
	
    validators = {"select_parent": validators.Int(if_invalid=0),  \
		  "parent_now_id": validators.Int(if_invalid=0), \
		  "button_add": validators.UnicodeString(if_invalid=u""), \
		  "button_del": validators.UnicodeString(if_invalid=u""), \
		  "button_select": validators.UnicodeString(if_invalid=u""), \
		  "available": validators.Set(if_invalid=[]), \
		  "employed": validators.Set(if_invalid=[]) }
				 
    def setup(self):
 	   self.msg_unexpected = "ERROR: unexpected SQL error. Contact the system administrator"
	   self.msg_notfound = "User not found, probably it has just been deleted"
           self.msg_updated = "User has been updated"
           self.msg_validation_crash = "Unexpected validation error: notify system administrator!"
           self.msg_validation = self.msg_validation_crash
	   self.parent_table = xuser
    	   self.child_table = orgs
    	   self.cross_table = user_org
    	   self.add_child_method = self.parent_table.addOrgs
    	   self.del_child_method = self.parent_table.removeOrgs
    	   self.parent_name = "user_name"
    	   self.child_name = "name"
    	   self.parent_order = self.parent_table.q.user_name
    	   self.child_order = self.child_table.q.name
     	   self.no_parent = "(None - please select an user)"
     	   self.parent_children_property = "orgs"

	   # special ACL that is accepted as valid permission
	   self.vips = ["ADMIN"]

    def check(self, parent_now_id, employed, available, action):
	   return ""

# EXPOSED METHODS ########################################################

    @expose(template="luca.templates.sys_usersXorgs")
    @validate(validators=validators)
    def index(self, select_parent=0, parent_now_id=0, employed=[], available=[], 
			button_add="", button_del="", button_select="", **garbage):
        return self.base_index(select_parent, parent_now_id, employed, available,
				button_add, button_del, button_select)

    @expose(template="luca.templates.sys_usersXorgs_lite")
    @validate(validators=validators)
    def lite(self, select_parent=0, parent_now_id=0, employed=[], available=[], 
			button_add="", button_del="", button_select="", **garbage):
        return self.base_index(select_parent, parent_now_id, employed, available,
				button_add, button_del, button_select)

