<?xml version='1.0' encoding='UTF-8'?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns='http://www.w3.org/1999/xhtml' xmlns:py='http://purl.org/kid/ns#' py:extends="'master.kid'">
  <?python from luca.mylib import dtoc
from luca.batches import test_cancelled
?>
  <head>
    <title>${title}</title>
    <SCRIPT SRC='/static/javascript/batches.js' TYPE='text/javascript' defer='defer'/>
    <SCRIPT SRC='/static/javascript/tables.js' TYPE='text/javascript' defer='defer'/>
    <SCRIPT SRC='/static/javascript/twolevel_tables.js' TYPE='text/javascript' defer='defer'/>
  </head>
  <body onLoad='ajax_setup()'>
    <h3>${title}</h3>
    <div class='hidden' id='formdiv'>
      <form onsubmit='return ajax_submit()' name='f' method='get'>
        <fieldset>
          <legend id='legend'/>
          <div>
            <div id='waiting' class='hidden'>
              <img src='/static/images/waiting.gif'/>
            </div>
            <div id='waitingpad' class='shown'/>
            <div id='errmsg'/>
            <div id='infomsg'/>
            <div class='clearer'/>
          </div>
          <table>
            <tr>
              <td>Description</td>
              <td>
                <input maxlength='60' type='text' name='description' value='' size='60'/>
              </td>
            </tr>
            <tr>
              <td>Initial date</td>
              <td>
                <input maxlength='12' type='text' name='date1' value='' size='12'/>
              </td>
            </tr>
            <tr>
              <td>Final date</td>
              <td>
                <input maxlength='12' type='text' name='date2' value='' size='12'/>
              </td>
            </tr>
            <tr>
              <td>Checksum
		</td>
              <td>
                <input maxlength='15' type='text' name='total' value='' size='15'/>
		zero = no checksum; do not any the decimal point or comma
		</td>
            </tr>
            <tr>
              <td>Status</td>
              <td>
                <select name='closed' value=''>
                  <option py:for='item in closedlist' value="${item['id']}">
                    <span py:content="item['description']"/>
                  </option>
                </select>
              </td>
            </tr>
            <tr>
              <td>Type</td>
              <td>
                <select name='adjust' value='0'>
                  <option py:for='item in adjustlist' value="${item['id']}">
                    <span py:content="item['description']"/>
                  </option>
                </select>
              </td>
            </tr>
          </table>
          <input type='hidden' name='id' value=''/>
          <input type='hidden' name='org' value='${org}'/>
          <input type='hidden' name='table_version' value='${table_version}'/>
          <button type='button' name='bsubmit' onClick='ajax_commit()'>Submit</button>
          <button type='button' name='bcancel' onClick='ajax_cancel()'>Cancel</button>
          <button type='button' name='bremove' onClick='ajax_remove()'>Remove</button>
        </fieldset>
      </form>
    </div>
    <div class='motherdata' id='motherdata'>
      <form name='motherselect' method='get'>
		Parent organization being edited: 
		<select name='mother' value='0'><option selected="${mother['id'] == org and 'x' or None}" py:for='mother in mothers' value="${mother['id']}"><span py:content="mother['description']">Organization name</span>
          </option>
        </select>
      </form>
    </div>
    <div id='addrow' class='shown'>
      <a href='javascript:ajax_new()'>Add new batch</a>
    </div>
    <div py:contents='softerr' class='errmsg2' py:if='softerr'>
    </div>
    <div class='tabledata' id='tabledata'>
      <table>
        <thead>
          <tr>
            <th>#</th>
            <th>Description</th>
            <th>Initial day</th>
            <th>Final day</th>
            <th>Status</th>
            <th/>
            <th/>
            <th/>
          </tr>
        </thead>
        <tbody>
          <tr class='newrow_invisible' id='newrow_invisible'>
            <td>
              <span id='idFNEW'/>
            </td>
            <td>
              <span id='descriptionFNEW'/>
            </td>
            <td>
              <span id='date1FNEW'/>
            </td>
            <td>
              <span id='date2FNEW'/>
            </td>
            <td>
              <a href='javascript:ajax_closed(${org}, FNEWID)'>
                <span id='closedFNEW'/>
              </a>
            </td>
            <td/>
            <td>
              <a href='javascript:ajax_edit_mother(${org}, FNEWID)' class='edit'>Edit</a>
            </td>
            <td>
              <a href="${tg.url('/journals', grandmother=org, mother='FNEWID')}" class='edit'>Go to journals</a>
            </td>
          </tr>
          <tr py:for='i, row in enumerate(rows)' class="${i % 2 and 'odd' or 'even'}" id="${'tr'+str(row.id)}">
            <td>
              <span id="${'idF'+str(row.id)}" py:content='row.id'>X</span>
            </td>
            <td>
              <span id="${'descriptionF'+str(row.id)}" py:content='row.description'>X</span>
            </td>
            <td>
              <span id="${'date1F'+str(row.id)}" py:content='dtoc(row.date1)'>X</span>
            </td>
            <td>
              <span id="${'date2F'+str(row.id)}" py:content='dtoc(row.date2)'>X</span>
            </td>
            <td>
              <a href='javascript:ajax_closed(${org}, ${row.id})'>
                <span id="${'closedF'+str(row.id)}" py:content="row.closed and 'Closed' or 'Open'"/>
              </a>
            </td>
            <td>
              <span py:content="test_cancelled(row.journals) and 'All entries cancelled' or None"/>
            </td>
            <td>
              <a href='javascript:ajax_edit_mother(${org}, ${row.id})' class='edit'>Edit</a>
            </td>
            <td>
              <a href="${tg.url('/journals', grandmother=org, mother=row.id)}" class='edit'>Go to journals</a>
            </td>
          </tr>
        </tbody>
      </table>
    </div>
    <div/>
  </body>
</html>
