<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xmlns:py="http://purl.org/kid/ns#"
    py:extends="'master.kid'">
<!--!
Author: Christopher Arndt
Revision: $Rev$
Date: $Date$
License: LGPL
-->

<head>
    <title>Currencies</title>

    <script src="/static/javascript/currencies.js" type="text/javascript"
      defer="defer"></script>
    <script src="/static/javascript/tables.js" type="text/javascript"
      defer="defer"></script>
</head>

<body onLoad="ajax_setup()">
  <h3>Currencies</h3>

  <h4>Download exchange rates</h4>

  <p><a href="#" class="hidden"
    id="download_rates_form_toggle">&gt;&gt;</a></p>

  <div id="download_rates_form_div">
    ${download_rates_form(**download_rates_form_data)}
  </div>

  <h4>Import currency list from XML file</h4>

  <p><a href="#" class="hidden"
    id="import_currencies_form_toggle">&gt;&gt;</a></p>

  <div id="import_currencies_form_div">

    <p>Upload or enter the URL of an XML file with a list of currencies.
    An example file can be found <a
    href="http://www.unece.org/etrades/unedocs/repository/codelists/xml/CurrencyCodeList.xml">here</a>.</p>

    ${import_currencies_form(**import_currencies_form_data)}
  </div>

  <div id="waiting" class="hidden">
    <img src="/static/images/waiting.gif"/>
  </div>
  <div id="waitingpad" class="shown"></div>

  <div class="hidden" id="msgdiv">
    <div id="ajax_msg" />
    <a href="javascript:setElementClass('msgdiv', 'hidden');">Hide messages</a>
  </div>

  <div class="hidden" id="formdiv">
  <form name="f" method="get" onsubmit="return ajax_submit()">
    <fieldset>
      <legend id="legend"></legend>
      <div>
        <div id="errmsg">&nbsp;</div>

        <div id="infomsg">&nbsp;</div>

        <div class="clearer"></div>
      </div>
      <table>
        <tr>
          <td>Currency code</td>
          <td>
            <input name="code" type="text" value="" size="3" maxlength="3" />          </td>
        </tr>
        <tr>
          <td>Currency name</td>
          <td>
            <input name="name" type="text" value="" size="40" maxlength="100" />          </td>
        </tr>
        <tr>
          <td>Download rates from FRB NY?</td>
          <td>
            <select name="autoDownload">
              <option value="1">
                Yes
              </option>
              <option value="0">
                No
              </option>
            </select>
          </td>
        </tr>
      </table>
      <input type="hidden" name="id" value=""/>
      <input type="hidden" name="table_version" value="${table_version}"/>
      <button type="button" name="bsubmit" onClick="ajax_commit()"
        >Submit</button>
      <button type="button" name="bcancel" onClick="ajax_cancel()"
        >Cancel</button>
      <button type="button" name="bremove" onClick="ajax_remove()"
        >Remove</button>
    </fieldset>
  </form>
  </div>

  <div id="addrow" class="shown"> <a href="javascript:ajax_new()">Add new
    currency</a> </div>

  <div class="tabledata" id="tabledata">
  <table>
    <thead>
      <tr>
          <th>Currency code</th>
          <th>Currency name</th>
          <th>Download?</th>
          <th></th>
      </tr>
    </thead>
    <tbody>

      <tr class="newrow_invisible" id="newrow_invisible">
          <td>
            <span id="codeFNEW"></span>
          </td>
          <td>
            <span id="nameFNEW"></span>
          </td>
          <td>
            <span id="autoDownloadFNEW"></span>
          </td>
          <td>
            <a class="view" href="${tg.url('/currency_rates/index?code=codeFNEW')}"
              >View</a>
            <a class="edit" href='javascript:ajax_edit(FNEWID)'>Edit</a>
          </td>
      </tr>

      <tr py:for="i, row in enumerate(rows)"
        class="${i % 2 and 'odd' or 'even'}" id="${'tr'+str(row.id)}">
        <td>
          <span py:content="row.code" id="${'codeF'+str(row.id)}">Currency
            code</span>
        </td>
        <td>
          <span py:content="row.name" id="${'nameF'+str(row.id)}">Currency
            name</span>
        </td>
        <td>
          <span py:if="row.autoDownload" id="${'autoDownloadF'+str(row.id)}"
            >Yes</span>
          <span py:if="not row.autoDownload" id="${'autoDownloadF'+str(row.id)}"
            >No</span>
        </td>
        <td>
          <a class="view"
            href="${tg.url('/currency_rates/index?code=%s' % row.code)}">View</a>
          <a class="edit" href="javascript:ajax_edit(${row.id})">Edit</a>
        </td>
      </tr>
    </tbody>
  </table>
  </div>

  <div>&nbsp;</div>
</body>
</html>

