<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xmlns:py="http://purl.org/kid/ns#"
    py:extends="'master.kid'">
<!--!
Author: Christopher Arndt
Revision: $Rev$
Date: $Date$
License: LGPL
-->

<head>
    <title>Currency exchange rates</title>

    <script src="/static/javascript/currency_rates.js" type="text/javascript"
      defer="defer"></script>
    <script src="/static/javascript/tables.js" type="text/javascript"
      defer="defer"></script>
</head>

<body onLoad="ajax_setup()" onsubmit="return false">
  <h3>Exchange rates for currency ${currency.code} (${currency.name})</h3>

  <div class="shown navlink"><a href="${tg.url('/currencies/')}">Back
    to currencies</a></div>

  <div py:if="currency.autoDownload" py:strip="">

  <h4>Download exchange rates for currrency ${currency.code}
    (${currency.name})</h4>

  <p><a href="#" class="hidden" id="download_rates_form_toggle">&gt;&gt;</a></p>

  <div id="download_rates_form_div">
    ${download_rates_form(**download_rates_form_data)}
  </div>
  </div>

  <div id="waiting" class="hidden">
    <img src="/static/images/waiting.gif"/>
  </div>
  <div id="waitingpad" class="shown"></div>

  <div class="hidden" id="msgdiv">
    <div id="ajax_msg" />
    <a href="javascript:setElementClass('msgdiv', 'hidden');">Hide messages</a>
    / <a href="javascript:location.reload();">Reload page</a>
  </div>

  <div class="hidden" id="formdiv">
  <form name="f" method="get" onsubmit="return ajax_submit()">
    <fieldset>
      <legend id="legend"></legend>
      <div>
        <div id="waiting" class="hidden">
          <img src="/static/images/waiting.gif"/>
        </div>

        <div id="waitingpad" class="shown"></div>

        <div id="errmsg">&nbsp;</div>

        <div id="infomsg">&nbsp;</div>

        <div class="clearer"></div>
      </div>
      <table>
        <tr>
          <td>Date</td>
          <td>
            <input name="date" type="text" value="" size="10" maxlength="10" />          </td>
        </tr>
        <tr>
          <td>Exchange rate</td>
          <td>
            <input name="fxrate" type="text" value="" size="10" maxlength="15" />          </td>
        </tr>
      </table>
      <input type="hidden" name="id" value=""/>
      <input type="hidden" name="currency" value=""/>
      <input type="hidden" name="manualOverride" value=""/>
      <input type="hidden" name="table_version" value="${table_version}"/>
      <button type="button" name="bsubmit" onClick="ajax_commit()"
        >Submit</button>
      <button type="button" name="bcancel" onClick="ajax_cancel()"
        >Cancel</button>
      <button type="button" name="bremove" onClick="ajax_remove()"
        >Remove</button>
    </fieldset>
  </form>
  </div>

  <div id="addrow" class="shown"><a
    href="javascript:ajax_crate_new(${currency.id})">Add new exchange rate for
    this currency</a></div>

  <div class="tabledata" id="tabledata">
  <table>
    <thead>
      <tr>
          <th>Date</th>
          <th>Exchange rate</th>
          <th>Manual?</th>
          <th></th>
      </tr>
    </thead>
    <tbody>

      <tr class="newrow_invisible" id="newrow_invisible">
          <td>
            <span id="dateFNEW"></span>
          </td>
          <td>
            <span id="fxrateFNEW"></span>
          </td>
          <td>
            <span id="manualOverrideFNEW"></span>
          </td>
          <td>
            <a class="edit" href='javascript:ajax_edit(FNEWID)'>Edit</a>
          </td>
      </tr>

      <tr py:for="i, row in enumerate(rows)"
        class="${i % 2 and 'odd' or 'even'}" id="${'tr'+str(row.id)}">
        <td>
          <span py:content="row.date" id="${'dateF'+str(row.id)}">FX rate
            date</span>
        </td>
        <td class="${row.manualOverride % 2 and 'manual_override' or ''}">
          <span py:content="row.fxrate" id="${'fxrateF'+str(row.id)}">FX rate</span>
        </td>
        <td class="${row.manualOverride % 2 and 'manual_override' or ''}">
          <span py:if="row.manualOverride" id="${'manualOverrideF'+str(row.id)}"
            >Yes</span>
          <span py:if="not row.manualOverride"
            id="${'manualOverrideF'+str(row.id)}">No</span>
        </td>
        <td>
          <a class="edit" href="javascript:ajax_edit(${row.id})">Edit</a>
        </td>
      </tr>
    </tbody>
  </table>
  </div>

  <div>&nbsp;</div>
</body>
</html>

