<?xml version='1.0' encoding='UTF-8'?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns='http://www.w3.org/1999/xhtml' xmlns:py='http://purl.org/kid/ns#' py:extends="'master.kid'">
  <?python import time
?>
  <head>
    <title>${title}</title>
    <SCRIPT SRC='/static/javascript/report_balance.js' TYPE='text/javascript' defer='defer'/>
  </head>
  <body>
    <h3>${title}</h3>
    <div class='shown' id='formdiv'>
      <form name='f' method='get'>
        <fieldset>
          <legend id='legend'>Report options</legend>
          <table>
            <tr>
              <td>Organization</td>
              <td>
                <select name='org' value='0'>
                  <option selected="${x['id'] == org and '1' or None}" py:for='x in orgs' value="${x['id']}">
                    <span py:content="x['name']">Name</span>
                  </option>
                </select>
              </td>
            </tr>
            <tr>
              <td>Period</td>
              <td>
                <input maxlength='12' type='text' name='date1' value='${date1}' size='12'/>
		to 
		<input maxlength='12' type='text' name='date2' value='${date2}' size='12'/>
              </td>
            </tr>
          </table>
          <input type='hidden' name='submitted' value='1'/>
          <button type='submit' name='submit'>Run report</button>
        </fieldset>
      </form>
    </div>
    <div>
    </div>
    <div py:if='rows' id='tabledata' class='tabledata'>
      <table>
        <thead>
          <tr>
            <th class='collapse'>
              <a href='javascript:ajax_uncollapse_all()'>+</a>
            </th>
            <th/>
            <th class='number'>Expense (debit)</th>
            <th class='number'>Revenue (credit)</th>
          </tr>
        </thead>
        <tbody>
          <tr code_class="${row['code_class']}" leaf="${row['leaf']}" py:for='i, row in enumerate(rows)' class="${row['css_row']}  ${row['collapse_class']}" id="${row['code_class']}">
            <td class='collapse'>
              <a href="javascript:ajax_collapse('${row['code_class']}')" py:if="not row['leaf']">+</a>
            </td>
            <td>
              <span py:for="x in xrange(1, row['level'])"/>
              <a href="${tg.url('/report_ledger', **row['ledger_params'])}" py:if="not row['aggregate']">
			${row['code']}
		</a>
              <span py:if="row['aggregate']">
                <span py:content="row['code']"/>
              </span>
              <span py:content="row['description']"/>
            </td>
            <td class='number'>
              <span py:if="row['db']" py:content="row['db']"/>
            </td>
            <td class='number'>
              <span py:if="row['cr']" py:content="row['cr']"/>
            </td>
          </tr>
        </tbody>
        <tfoot>
          <tr py:if='rows' class='bottomline'>
            <td class='collapse'/>
            <td>
		Net profit (loss)
	    </td>
            <td class='number negative'>
              <span py:if='dbsum' py:content='dbsum'>
              </span>
            </td>
            <td class='number'>
              <span py:if='crsum' py:content="'+'+crsum">
              </span>
            </td>
          </tr>
        </tfoot>
      </table>
    </div>
    <div class='timestamp' py:content='timestamp' py:if='rows'/>
  </body>
</html>
