<?xml version='1.0' encoding='UTF-8'?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns='http://www.w3.org/1999/xhtml' xmlns:py='http://purl.org/kid/ns#' py:extends="'master.kid'">
  <head>
    <title>System users</title>
    <SCRIPT SRC='/static/javascript/sys_users.js' TYPE='text/javascript' defer='defer'/>
    <SCRIPT SRC='/static/javascript/tables.js' TYPE='text/javascript' defer='defer'/>
  </head>
  <body onLoad='ajax_setup()'>
    <h3>System Users</h3>
    <div class='hidden' id='formdiv'>
      <form onsubmit='return ajax_submit()' name='f' method='get'>
        <fieldset>
          <legend id='legend'/>
          <div>
            <div id='errmsg'/>
            <div id='infomsg'/>
            <div id='waiting' class='hidden'>
              <img src='/static/images/waiting.gif'/>
            </div>
            <div id='waitingpad' class='shown'/>
            <div class='clearer'/>
          </div>
          <table>
            <tr>
              <td>Nickname</td>
              <td>
                <input maxlength='16' type='text' name='user_name' value='' size='16'/>
              </td>
            </tr>
            <tr>
              <td>User name</td>
              <td>
                <input maxlength='40' type='text' name='display_name' value='' size='30'/>
              </td>
            </tr>
            <tr>
              <td>E-mail</td>
              <td>
                <input maxlength='100' type='text' name='email_address' value='' size='40'/>
              </td>
            </tr>
            <tr>
              <td>Password</td>
              <td>
                <input maxlength='16' type='text' name='password' value='' size='16'/> (fill only if you want to change)</td>
            </tr>
            <tr>
              <td>Thousand separator</td>
              <td>
                <select name='thousand_separator'>
                  <option py:for='item in thousand_separators' value="${item['id']}">
                    <span py:content="item['description']"/>
                  </option>
                </select>
              </td>
            </tr>
            <tr>
              <td>Decimal separator</td>
              <td>
                <select name='decimal_separator'>
                  <option py:for='item in decimal_separators' value="${item['id']}">
                    <span py:content="item['description']"/>
                  </option>
                </select>
              </td>
            </tr>
            <tr>
              <td>Date format</td>
              <td>
                <select name='date_format'>
                  <option py:for='item in date_formats' value="${item['id']}">
                    <span py:content="item['description']"/>
                  </option>
                </select>
              </td>
            </tr>
            <tr>
              <td>AJAX capabilities</td>
              <td>
                <select name='lite'>
                  <option py:for='item in lite_options' value="${item['id']}">
                    <span py:content="item['description']"/>
                  </option>
                </select>
              </td>
            </tr>
          </table>
          <input type='hidden' name='id' value=''/>
          <input type='hidden' name='table_version' value='${table_version}'/>
          <button type='button' name='bsubmit' onClick='ajax_commit()'>Submit</button>
          <button type='button' name='bcancel' onClick='ajax_cancel()'>Cancel</button>
          <button type='button' name='bremove' onClick='ajax_remove()'>Remove</button>
        </fieldset>
      </form>
    </div>
    <div id='addrow' class='shown'>
      <a href='javascript:ajax_new()'>Add new user</a>
    </div>
    <div class='tabledata' id='tabledata'>
      <table>
        <thead>
          <tr>
            <th>#</th>
            <th>Nickname</th>
            <th>Full name</th>
            <th>E-mail</th>
            <th/>
          </tr>
        </thead>
        <tbody>
          <tr class='newrow_invisible' id='newrow_invisible'>
            <td>
              <span id='idFNEW'/>
            </td>
            <td>
              <span id='user_nameFNEW'/>
            </td>
            <td>
              <span id='display_nameFNEW'/>
            </td>
            <td>
              <span id='email_addressFNEW'/>
            </td>
            <td>
              <a href='javascript:ajax_edit(FNEWID)' class='edit'>Edit</a>
            </td>
          </tr>
          <tr py:for='i, row in enumerate(rows)' class="${i % 2 and 'odd' or 'even'}" id="${'tr'+str(row.id)}">
            <td>
              <span id="${'idF'+str(row.id)}" py:content='row.id'/>
            </td>
            <td>
              <span id="${'user_nameF'+str(row.id)}" py:content='row.user_name'>User nickname</span>
            </td>
            <td>
              <span id="${'display_nameF'+str(row.id)}" py:content='row.display_name'>Name</span>
            </td>
            <td>
              <span id="${'email_addressF'+str(row.id)}" py:content='row.email_address'>Name</span>
            </td>
            <td>
              <a href='javascript:ajax_edit(${row.id})' class='edit'>Edit</a>
            </td>
          </tr>
        </tbody>
      </table>
    </div>
    <div/>
  </body>
</html>
