import turbogears
from turbogears import controllers, redirect
from turbogears import identity

from luca.model import conn, notfound, sqlerror, modelerror, denied

from model import permission

from luca.simple_table import simple_table
from luca import mylib
import model

class threelevel_table(simple_table):

#    def setup(self):
#
#	All vars defined in simple_table::setup(), plus:
#
#	self.grandmother_table = model.orgs
#	self.mother_table = model.batches
#	self.grandmother_field_name = "org"
#	self.mother_field_name = "batch"
#	self.msg_grandmotherinvalid = "GrandMother ID invalid"
#	self.msg_motherinvalid = "Mother ID invalid"

    def test__index_lite(self, t, grandmother, mother): #pragma: no cover
	t.cargo = t.tu.call(self.lite, grandmother, mother)
	if not t.cargo["err"]:
		return True
	return False

    def test__index(self, t, grandmother, mother): #pragma: no cover
	t.cargo = t.tu.call(self.index, grandmother, mother)
	if not t.cargo["err"]:
		return True
	return False

    def test__fetch_lite(self, t, grandmother, mother, id): #pragma: no cover
	t.cargo = t.tu.call(self.lite_edit, grandmother, mother, id)
	if not t.cargo["err"]:
		return True
	return False

    def test__fetch(self, t, grandmother, mother, id): #pragma: no cover
	t.cargo = t.tu.call(self.fetch, grandmother, mother, id)
	if not t.cargo["err"]:
		return True
	return False

    def test__load_index(self, t): #pragma: no cover
	# TEST: fetching index page
	
	t.logmask = t.DONE

	if "index_is_fetch" in t.flags():  # req. index will trigger a fetch and hence will be logged
		t.logmask = 0

	t.forgive_org_permission_hole = 1 
	res = t.permission_explode("without grandmother/mother", self.test__index, t.DONE, 0, 0)
	if not res:
		t.fail("Failed")
	res = t.permission_explode("without grandmother", self.test__index, t.DONE, 0, 1)
	if not res:
		t.fail("Failed")
	res = t.permission_explode("without grandmother/mother", self.test__index_lite, t.DONE, 0, 0)
	if not res:
		t.fail("Failed")
	res = t.permission_explode("without grandmother", self.test__index_lite, t.DONE, 0, 1)
	if not res:
		t.fail("Failed")
	t.forgive_org_permission_hole = 0
	res = t.permission_explode("without mother", self.test__index, t.DONE, 1, 0)
	if not res:
		t.fail("Failed")
	res = t.permission_explode("complete", self.test__index, t.DONE, 1, 1)
	if not res:
		t.fail("Failed")
	res = t.permission_explode("without mother", self.test__index_lite, t.DONE, 1, 0)
	if not res:
		t.fail("Failed")
	res = t.permission_explode("complete", self.test__index_lite, t.DONE, 1, 1)
	if not res:
		t.fail("Failed")

    def test__reload_index(self, t):	 #pragma: no cover
	# TEST: fetching index page again
	
	t.logmask = t.DONE

	if "index_is_fetch" in t.flags():  # req. index will trigger a fetch and hence will be logged
		t.logmask = 0

	t.forgive_org_permission_hole = 1 
	res = t.permission_explode("AGAIN without grandmother/mother", self.test__index, t.DONE, 0, 0)
	if not res:
		t.fail("Failed")
	res = t.permission_explode("AGAIN without grandmother", self.test__index, t.DONE, 0, 1)
	if not res:
		t.fail("Failed")
	res = t.permission_explode("AGAIN without grandmother/mother", self.test__index_lite, t.DONE, 0, 0)
	if not res:
		t.fail("Failed")
	res = t.permission_explode("AGAIN without grandmother", self.test__index_lite, t.DONE, 0, 1)
	if not res:
		t.fail("Failed")
	t.forgive_org_permission_hole = 0
	res = t.permission_explode("AGAIN without mother", self.test__index, t.DONE, 1, 0)
	if not res:
		t.fail("Failed")
	res = t.permission_explode("AGAIN complete", self.test__index, t.DONE, 1, 1)
	if not res:
		t.fail("Failed")
	res = t.permission_explode("AGAIN without mother", self.test__index_lite, t.DONE, 1, 0)
	if not res:
		t.fail("Failed")
	res = t.permission_explode("AGAIN complete", self.test__index_lite, t.DONE, 1, 1)
	if not res:
		t.fail("Failed")

    def test__fetch_empty_row_core(self, t): #pragma: no cover
	res = t.permission_explode("fetch empty", self.test__fetch, t.DONE, 1, 1, 0)
	res2 = t.permission_explode("fetch empty", self.test__fetch_lite, t.DONE, 1, 1, 0)
	return (res, res2)

    def test__fetch_nonexistent(self, t): #pragma: no cover
	t.logmask = t.FAIL + t.DENIED
	res = t.permission_explode("fetch nonexistent", self.test__fetch, t.DONE, 1, 1, 999)
	if res:
		t.fail("Should have failed fetch 999")

    def test__valid_fetch_lite(self, t): #pragma: no cover
	if 'cant_fetch_by_id' not in t.flags():
		if not t.permission_granted("valid fetch (lite)", self.test__fetch_lite, t.DONE, \
					t.rows[-2][self.grandmother_field_name], t.rows[-2][self.mother_field_name], t.rows[-2]["id"]):
			t.fail("Failed to fetch %d" % t.rows[-2]["id"])

    def test__row_fetch(self, t, row): #pragma: no cover
	t.logmask = 0
	res = t.permission_explode("normal", self.test__fetch, t.DONE, row[self.grandmother_field_name], row[self.mother_field_name], row["id"])
	if not res:
		t.fail("Failed fetch %d" % row["id"])

    def test__row_fetch_lite(self, t, row): #pragma: no cover
	t.logmask = 0
	res = t.permission_explode("lite", self.test__fetch_lite, t.DONE, row[self.grandmother_field_name], row[self.mother_field_name], row["id"])
	if not res:
		t.fail("Failed fetch lite %d" % row["id"])


    def __init__(self, log):
        super(threelevel_table, self).__init__(log)
	self.streamlined_add = True

    def make_title(self, grandmother, mother):
	raise Exception("Please override this method!") #pragma: no cover

    def grandmother_check(self, grandmother):
	try:
		self.grandmother_table.get(grandmother)
	except sqlerror:  #pragma: no cover
		return False
	return True

    def mother_check(self, grandmother, mother):
	try:
		r = self.mother_table.get(mother)
		if getattr(r, self.grandmother_field_name).id != grandmother:
			return False
	except sqlerror:  #pragma: no cover
		return False
	return self.mother_check_ext(grandmother, mother, r)

    def base_index(self, lite, grandmother, mother):
	# shadows completely the superclass 
	if grandmother <= 0:
		grandmother_session = mylib.getdefault(self, self.grandmother_field_name, grandmother, 0)
		if grandmother_session > 0:
			if not self.grandmother_check(grandmother_session):
				mylib.setdefault(self, self.grandmother_field_name, 0, 0)
			elif lite:
				raise redirect(turbogears.url("lite", grandmother=grandmother_session, mother=0))
			else:
				raise redirect(turbogears.url("./", grandmother=grandmother_session, mother=0))
	if mother <= 0:
		mother_session = mylib.getdefault(self, self.mother_field_name, mother, 0)
		if mother_session > 0:
			if not self.mother_check(grandmother, mother_session):
				mylib.setdefault(self, self.mother_field_name, 0, 0)
			elif lite:
				raise redirect(turbogears.url("lite", grandmother=grandmother, mother=mother_session))
			else:
				raise redirect(turbogears.url("./", grandmother=grandmother, mother=mother_session))
	err = ""
	softerr = ""
	title = self.make_title(grandmother, mother)
	rows = []
	extradata = {}
	table_version = -1
	grant = None
	try:
		grant = permission(self, "read", self.perm_org({"org": grandmother}), permission.MASK_DONE, "Parent %d" % mother)
       		rows, err, softerr, extradata = self.get_index_rows(grandmother, mother)
		table_version = self.table_version({"grandmother": grandmother, "mother": mother})
		if not err:
			mylib.setdefault(self, self.grandmother_field_name, grandmother, 0)
			mylib.setdefault(self, self.mother_field_name, mother, 0)
	except denied, e:
		err = e.args[0]
	except sqlerror, e:  #pragma: no cover
		err = self.sqlerr(e)

	if grant:
		if err:
			grant.fail(err)
		grant.done()

	form_data = {"rows": rows, self.grandmother_field_name: grandmother, self.mother_field_name: mother, "softerr": softerr, "table_version": table_version, "title": title}
	form_data.update(extradata)

	try:
		self.auxiliary_form_data(form_data)
	except sqlerror, e:  #pragma: no cover
		err = "SQL error inside auxiliary_form_data"

	if err:
		self.flash(form_data, err, True)
	elif self._indexflash:
		self.flash(form_data, self._indexflash, self._indexflash_err)
	self._indexflash = None

	form_data["err"] = err

	return form_data

    def base_fetch(self, grandmother, mother, id):
	fixed_values = {}
	fixed_values[self.grandmother_field_name] = grandmother
	fixed_values[self.mother_field_name] = mother
        form_data = super(threelevel_table, self).base_fetch(id, fixed_values)
	if id <= 0:
		if (grandmother <= 0) and not form_data["err"]:
			form_data["err"] = self.msg_grandmotherinvalid
		if (mother <= 0) and not form_data["err"]:
			form_data["err"] = self.msg_motherinvalid
	else:
		pass
	return form_data

    def base_lite_edit(self, grandmother, mother, id):
	form_data = self.base_fetch(grandmother, mother, id)

      	if form_data["err"]:
		self.flash_at_index(form_data["err"], err=1)
		self._editflash = None
		if model._testing_:
			return form_data
		raise redirect(turbogears.url("lite", grandmother=grandmother, mother=mother)) #pragma: no cover

	if self._editflash:
		self.flash(form_data, self._editflash, self._editflash_err)
		self._editflash = None

 	if id <= 0:
 		form_data[self.grandmother_field_name] = grandmother
		if grandmother <= 0:
			form_data["err"] = self.msg_grandmotherinvalid

	try:
		err = self.auxiliary_form_data(form_data)
	except sqlerror, e:  #pragma: no cover
		form_data["err"] = "SQL error inside auxiliary_form_data"

 	return form_data

