
import turbogears
from turbogears import controllers, redirect
from turbogears import identity

from luca.model import conn, notfound, sqlerror, modelerror, denied

from model import permission

from luca.simple_table import simple_table
from luca import mylib

import model

class twolevel_table(simple_table):

#    def setup(self):
#
#	All vars defined in simple_table::setup(), plus:
#
#	self.mother_table = model.chart
#	self.mother_field_name = "chart"
#	self.msg_motherinvalid = "Mother ID invalid"

    def test__index_lite(self, t, mother): #pragma: no cover
	t.cargo = t.tu.call(self.lite, mother)
	if not t.cargo["err"]:
		return True
	return False

    def test__index(self, t, mother): #pragma: no cover
	t.cargo = t.tu.call(self.index, mother)
	if not t.cargo["err"]:
		return True
	return False

    def test__fetch_lite(self, t, mother, id): #pragma: no cover
	t.cargo = t.tu.call(self.lite_edit, mother, id)
	if not t.cargo["err"]:
		return True
	return False

    def test__fetch(self, t, mother, id): #pragma: no cover
	t.cargo = t.tu.call(self.fetch, mother, id)
	if not t.cargo["err"]:
		return True
	return False

    def test__mobile(self, t, mother, id): #pragma: no cover
	t.cargo = t.tu.call(self.mobile, mother, id)
	if not t.cargo["err"]:
		return True
	return False

    def test__inactive(self, t, mother, id): #pragma: no cover
	t.cargo = t.tu.call(self.inactive, mother, id)
	if not t.cargo["err"]:
		return True
	return False

    def test__closed(self, t, mother, id): #pragma: no cover
	t.cargo = t.tu.call(self.closed, mother, id)
	if not t.cargo["err"]:
		return True
	return False

    def test__load_index(self, t): #pragma: no cover
	# TEST: fetching index page
	
	t.logmask = t.DONE

	if "index_is_fetch" in t.flags():  # req. index will trigger a fetch and hence will be logged
		t.logmask = 0

	t.forgive_org_permission_hole = 1 
	res = t.permission_explode("without mother", self.test__index, t.DONE, 0)
	if not res:
		t.fail("Failed")
	res = t.permission_explode("without mother", self.test__index_lite, t.DONE, 0)
	if not res:
		t.fail("Failed")
	t.forgive_org_permission_hole = 0
	res = t.permission_explode("complete", self.test__index, t.DONE, 1)
	if not res:
		t.fail("Failed")
	res = t.permission_explode("complete", self.test__index_lite, t.DONE, 1)
	if not res:
		t.fail("Failed")

    def test__reload_index(self, t):	 #pragma: no cover
	# TEST: fetching index page again
	
	t.logmask = t.DONE

	if "index_is_fetch" in t.flags():  # req. index will trigger a fetch and hence will be logged
		t.logmask = 0

	t.forgive_org_permission_hole = 1 
	res = t.permission_explode("AGAIN without mother", self.test__index, t.DONE, 0)
	if not res:
		t.fail("Failed")
	res = t.permission_explode("AGAIN without mother", self.test__index_lite, t.DONE, 0)
	if not res:
		t.fail("Failed")
	t.forgive_org_permission_hole = 0
	res = t.permission_explode("AGAIN complete", self.test__index, t.DONE, 1)
	if not res:
		t.fail("Failed")
	res = t.permission_explode("AGAIN complete", self.test__index_lite, t.DONE, 1)
	if not res:
		t.fail("Failed")


    def test__fetch_empty_row_core(self, t): #pragma: no cover
	res = t.permission_explode("fetch empty", self.test__fetch, t.DONE, 1, 0)
	res2 = t.permission_explode("fetch empty lite", self.test__fetch_lite, t.DONE, 1, 0)
	return (res, res2)

    def test__fetch_nonexistent(self, t): #pragma: no cover
	t.logmask = t.FAIL + t.DENIED
	res = t.permission_explode("fetch nonexistent", self.test__fetch, t.DONE, 1, 999)
	if res:
		t.fail("Should have failed fetch 999")

    def test__valid_fetch_lite(self, t): #pragma: no cover
	if 'cant_fetch_by_id' not in t.flags():
		if not t.permission_granted("valid fetch (lite)", self.test__fetch_lite, t.DONE, \
						t.rows[-2][self.mother_field_name], t.rows[-2]["id"]):
			t.fail("Failed to fetch %d" % t.rows[-2]["id"])

    def test__row_inactive(self, row): #pragma: no cover
	if not t.permission_explode("valid inactive", self.test__inactive, t.DONE, row[self.mother_field_name], row["id"]):
		t.fail("Failed inactive "+str(row))
	if not t.permission_explode("valid inactive", self.test__inactive, t.DONE, row[self.mother_field_name], row["id"]):
		t.fail("Failed inactive "+str(row))

    def test__row_mobile(self, row): #pragma: no cover
	if not t.permission_explode("valid mobile", self.test__mobile, t.DONE, row[self.mother_field_name], row["id"]):
		t.fail("Failed mobile "+str(row))

    def test__row_fetch(self, t, row): #pragma: no cover
	t.logmask = 0
	res = t.permission_explode("normal", self.test__fetch, t.DONE, row[self.mother_field_name], row["id"])
	if not res:
		t.fail("Failed fetch %d" % row["id"])

    def test__row_fetch_lite(self, t, row): #pragma: no cover
	t.logmask = 0
	res = t.permission_explode("lite", self.test__fetch_lite, t.DONE, row[self.mother_field_name], row["id"])
	if not res:
		t.fail("Failed fetch lite %d" % row["id"])


# BOILERPLATE CODE (INIT & ERRORS) ################################################
 
    def __init__(self, log):
        super(twolevel_table, self).__init__(log)
	self.streamlined_add = True

    def make_title(self, mother):
	raise Exception("Please override this method!") #pragma: no cover

    def mother_check(self, mother):
	try:
		self.mother_table.get(mother)
	except sqlerror:  #pragma: no cover
		return False
	return True

    def base_index(self, lite, mother):
	# shadows completely the superclass
	if mother <= 0:
		mother_session = mylib.getdefault(self, self.mother_field_name, mother, 0)
		if mother_session > 0:
			if not self.mother_check(mother_session):
				mylib.setdefault(self, self.mother_field_name, 0, 0)
			elif lite:
				raise redirect(turbogears.url("lite", mother=mother_session))
			else:
				raise redirect(turbogears.url("./", mother=mother_session))
	err = ""
	softerr = ""
	title = self.make_title(mother)
	rows = []
	extradata = {}
	table_version = -1
	grant = None
	try:
		grant = permission(self, "read", self.perm_org({"org": mother}), permission.MASK_DONE, "Parent %d" % mother)
        	rows, err, softerr, extradata = self.get_index_rows(mother)
		if not err:
			mylib.setdefault(self, self.mother_field_name, mother, 0)
		table_version = self.table_version({"mother": mother})

	except denied, e:
		err = e.args[0]
	except sqlerror, e:  #pragma: no cover
		err = self.sqlerr(e)
	
	if grant:
		if err:
			grant.fail(err)
		grant.done()

	form_data = {"rows": rows, self.mother_field_name: mother, "softerr": softerr, "table_version": table_version, "title": title}
	form_data.update(extradata)

	try:
		self.auxiliary_form_data(form_data)
	except sqlerror, e:  #pragma: no cover
		err = "SQL error inside auxiliary_form_data"

	if err:
		self.flash(form_data, err, True)
	elif self._indexflash:
		self.flash(form_data, self._indexflash, self._indexflash_err)
	self._indexflash = None

	form_data["err"] = err

	return form_data

    def base_fetch(self, mother, id):
	fixed_values = {}
	fixed_values[self.mother_field_name] = mother
        form_data = super(twolevel_table, self).base_fetch(id, fixed_values)
	if id <= 0:
		if mother <= 0 and not form_data["err"]:
			form_data["err"] = self.msg_motherinvalid
	else:
		pass
	return form_data

    def base_lite_edit(self, mother, id):
	form_data = self.base_fetch(mother, id)

        if form_data["err"]:
	  	# abort form display
		self.flash_at_index(form_data["err"], err=1)
		self._editflash = None
		if model._testing_:
			return form_data
		raise redirect(turbogears.url("lite", mother=mother)) #pragma: no cover

	if self._editflash:
		self.flash(form_data, self._editflash, self._editflash_err)
		self._editflash = None

 	if id <= 0:
 		form_data[self.mother_field_name] = mother
		if mother <= 0:
			form_data["err"] = self.msg_motherinvalid

	try:
		err = self.auxiliary_form_data(form_data)
	except sqlerror, e:  #pragma: no cover
		form_data["err"] = "SQL error inside auxiliary_form_data"

 	return form_data

    def base_lite_commit(self, form_data):
	# shadows completely the superclass
	is_streamlined = self.streamlined_add and form_data["id"] <= 0
	upd = self.base_update(form_data)
	if not upd["err"]:
		if is_streamlined:
			self.flash_at_edit(upd["msg"], err=0)
			if model._testing_:
				return upd
			raise redirect(turbogears.url("lite_edit", id=0, mother=form_data[self.mother_field_name])) #pragma: no cover
		self.flash_at_index(upd["msg"], err=0)
		if model._testing_:
			return upd
		raise redirect("lite") #pragma: no cover

	# send back all received data + the error message
	form_data = self.intermediate_to_form(self.form_to_intermediate(form_data))
	form_data.update(upd)
	err = ""
	try:
		err = self.auxiliary_form_data(form_data)
	except sqlerror, e:  #pragma: no cover
		err = "SQL error inside auxiliary_form_data"
	if err:
		form_data["err"] = err

	return form_data

