# Copyright (c) 2005 INdT - Instituto Nokia de Tecnologia, Elvis Pfutzenreuter.
# All rights reserved. This software is released under the LGPL licence.

import bluetooth
from mylib import CommError

exceptions = ( bluetooth.BluetoothError, )

ctbname = "CtbSyncService"

def device_list():
	try:
		neighbourhood = bluetooth.discover_devices(lookup_names = True)
	except exceptions, e:
		return ([], "Could not connect: %s" % repr(e.args))
	return (neighbourhood, "")
	
def client_socket(host):
	global ctbname
	
	try:
		service = None
		try:
			services = bluetooth.find_service(address = host, name = ctbname)
		except exceptions, err:
			print "Warning: error while querying device %s: %s" %  (host, err)

		if services:
			service = services[0]

		if not service:
			raise CommError("Service could not be found")
		
		port = service["port"]

	except exceptions, e:
		raise CommError("Could not connect: %s" % repr(e.args))
	
	try:
		sock = bluetooth.BluetoothSocket(bluetooth.RFCOMM)
		sock.connect((host, port))
		return sock

	except exceptions, e:
		raise CommError("Could not connect: %s" % repr(e.args))

