# Copyright (c) 2005 INdT - Instituto Nokia de Tecnologia, Elvis Pfutzenreuter.
# All rights reserved. This software is released under the LGPL licence.

import socket
from mylib import CommError

exceptions = ( socket.error, )

ctbname = "CtbSyncService"

def device_list():
	raise Exception("Not supported; S60 shows the device list by itself when connecting")

def client_socket(dummy):
	global ctbname

	try:
		host, services = socket.bt_discover()

	except exceptions:
		raise CommError("Service not found (err)")

	if not host:
		raise CommError("No server found!")

	if not services.has_key(ctbname):
		raise CommError("Service not found")

	port = services[ctbname]
	
	try:
		sock = socket.socket(socket.AF_BT, socket.SOCK_STREAM)
		sock.connect((host, port))
	
		return sock
	except exceptions, e:
		raise CommError("Could not connect: %s" % repr(e.args))

